//---------------------------------------------------------------------------
/*
Compute sun position and Muslims Salat times for particular date
Copyright (C) 2006  Lotfi BAGHLI

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*********************************************************
*** IF YOU ARE MUSLIM, PLEASE PRAY FOR MY FORGIVENESS ***
*********************************************************

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
//---------------------------------------------------------------------------
#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "maincmd.h"
#pragma warning( disable :  4244)
//---------------------------------------------------------------------------

const double M_PI=3.1415926535897932384626433832795;
const double deg2rd = M_PI/180.0;
const double rd2deg = 180.0/M_PI;
const double SolarSiderealCorrection = 1.002738;
		Astre Soleil;
		SalatTimeStruct SalatTime, SalatTimeC;
		double JD, T,  // Jour Julien, Julien Century : T,
					theta0, theta,  // theta0 : temps sideral  Greenwich
					longitude, latitude;
		DateUT date; // date en jours
		Heure heure; // date en heure
		int TimeZone, TimeZoneTown, NTowns, TownSelected, Verbose, Convention;
		int DST;
		SalatTimeConfigStruct SalatTimeConfig[NConvention];
		pTownData * Towns;
		TCHAR * Mounths[]={L"Janvier", L"Fvrier", L"Mars", L"Avril",
									L"Mai", L"Juin", L"Juillet", L"Aot",
									L"Septembre", L"Octobre", L"Novembre", L"Dcembre"};
		TCHAR * Days[]={L"Lundi", L"Mardi", L"Mercredi", L"Jeudi", L"Vendredi", L"Samedi", L"Dimanche"};
		const wchar_t FajrText[]={1601,1580,1585,0};
		const wchar_t ChouroukText[]={1588,1585,1608,1602,0};
		const wchar_t ZuhrText[]={1592,1607,1585,0};
		const wchar_t AsrText[]={1593,1589,1585,0};
		const wchar_t MaghribrText[]={1605,1594,1585,1576,0};
		const wchar_t IshaText[]={1593,1588,1575,1569,0};
		TCHAR	CountryName[Namelenght], TownName[Namelenght];

//---------------------------------------------------------------------------
// Algorithms from 	http://www.jgiesen.de/SME/details/basics/meeus.htm#solar
//								 	http://www.jgiesen.de/SME/details/basics/index.htm
//  								http://stjarnhimlen.se/comp/riset.html#3
//									http://www.ummah.net/astronomy/saltime/
// modified by Lotfi BAGHLI on 15/01/2006 et 10/06/2006
//---------------------------------------------------------------------------

// Julian day: 86400 s, Julian year: 365.25 d, Julian Century: 36525 d
// Julian Day (valid from 1900/3/1 to 2100/2/28)
double JulianDay (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
	return (int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0;
}
//---------------------------------------------------------------------------
// rang du jour
/*
double rang_du_jour (int date, int month, int year)
{                                                                                         
int N1, N2, K, N;
	N1=(month*275)/9;
	N2=(month+9)/12;
	K=1+ (year-4*(int)(year/4)+2)/3;
	(K=2 pour une anne commune et K=1 pour une bissextile)
	Le rang du jour est donn par :
	N=N1-N2*K+date-30;
	return N;
} pas ncessaire */
//---------------------------------------------------------------------------
// Julian century depuis 01/01/2000  12h UT
double JulianCentury (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
  return ((int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0 - 2451545.0)/36525;
} 
//---------------------------------------------------------------------------
//Solar Coordinates (according to: Jean Meeus: Astronomical Algorithms), accuracy of 0.01 degree 
double SoleilLongitude( double T)   // L
{
double M, L0, DL, L, Lm;
	M = 357.52910 + 35999.05030*T - 0.0001559*T*T - 0.00000048*T*T*T; // mean anomaly, degree
	L0 = 280.46645 + 36000.76983*T + 0.0003032*T*T; // mean longitude, degree 
	DL = (1.914600 - 0.004817*T - 0.000014*T*T)*sin(deg2rd*M)
				+ (0.019993 - 0.000101*T)*sin(deg2rd*2*M) + 0.000290*sin(deg2rd*3*M); 
	L=L0 + DL; // true longitude, deg sans modulo
	Lm=L-360*(int)(L/360);
	if (Lm<0)	Lm+=360;
	return Lm*deg2rd; // true longitude, rd 
}
//---------------------------------------------------------------------------
// convert ecliptic longitude L (rd) to right ascension RA and declination delta
void eclipticL2RA_delta( double L, double & RA, double & delta)
{
double eps, X, Y, Z, R;
  eps = deg2rd*23.43999; // obliquity of ecliptic
	X = cos(L); Y = cos(eps)*sin(L); Z = sin(eps)*sin(L); R = sqrt(1.0-Z*Z); 
	delta = atan2(Z, R); // in rd 
	RA = 2*atan2(Y, X+R); //  in rd 
}
//---------------------------------------------------------------------------
//compute sidereal time at Greenwich (according to: Jean Meeus: Astronomical Algorithms ) 
double TempsSideral( double T)   // theta0
{
	double theta0, theta0m;
//	T siecle julien depuis 2000
	theta0=280.46061837 + 360.98564736629*T*36525 + 0.000387933*T*T - T*T*T/38710000.0;
	theta0m=theta0-360*(int)(theta0/360);
	if (theta0m<0)	theta0m+=360;
	return theta0m*deg2rd;    // TempsSideralen rd
}
//---------------------------------------------------------------------------
//convert tau, delta to horizon coordinates of the observer (altitude h, azimuth az) , needs latitude : beta
void equatorial2horizontal( double beta, double tau, double delta, double & h, double & az)
{
	h=asin( sin(beta)*sin(delta) + cos(beta)*cos(delta)*cos(tau));	// h en rd
	az =atan2( -sin(tau), cos(beta)*tan(delta) - sin(beta)*cos(tau))-M_PI;	// az en rd du SUD
	if (az<0)	az+=2*M_PI;
}
//---------------------------------------------------------------------------
//convert rad en heure
double rd2heure( double angle)
{
	return (angle*12.0/M_PI);
}
//---------------------------------------------------------------------------
// check DST applies ou non
bool CalcTimeZone( int a, int m, int j, int DST, int TimeZoneTown)
{      // ici on approxime TimeZoneTown avec TimeZone puisque a n'a pas d'importance
int jjdebut, jjfin, mmdebut, mmfin, ji, jour, JourToSwitch;
double T;
	if (DST==2) {JourToSwitch=4; mmdebut=4; mmfin=9;} // dernier vendredi d'avril / septembre
			else		{JourToSwitch=6; mmdebut=3; mmfin=10;}// dernier dimanche de mars / octobre
// recherchedernier dimanche de mars et dernier dimanche d'octobre
// DST applys 26-Mar, 02:00h    29-Oct, 03:00h   pour 2006
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmdebut, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjdebut=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmfin, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjfin=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	if (m>mmdebut && m<mmfin)	return true;
	if (m==mmdebut && j>=jjdebut)	return true;
	if (m==mmfin && j<jjfin)	return true;
	return false;
}
//---------------------------------------------------------------------------
//convert heure en rad
double heure2rd( double heure)
{
	return (heure*M_PI/12.0);
}
//---------------------------------------------------------------------------
//convert rad en deg min sec
TCHAR * Lrd2degminsec( double angle, TCHAR * SS)
{
double h, m, s;
int hi, mi;
	h=angle*rd2deg;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	wsprintf (SS,L"%3d%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert rad en h min sec
TCHAR * Lrd2hminsec( double angle, TCHAR * SS)
{
double h, m, s;
int hi, mi;
	h=rd2heure(angle);
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	wsprintf (SS,L"%02dh%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert h en h min sec
TCHAR * Lh2hminsec( double h, TCHAR * SS)
{
double m, s;
int hi, mi;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	wsprintf (SS,L"%02dh%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert h en h min arondie		Long
TCHAR * Lh2hmiarrondie( double h, TCHAR * SS)
{
double m, s;
int hi, mi;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	if (s>=30)	{
							mi++;
							if (mi==60)	{
													mi=0; hi++;
													if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
																			wsprintf(SS, TEXT("erreur : arrondi au jour suivant"));
																			return SS;
						                          }	
													}
							}
	wsprintf(SS, TEXT("%02d:%02d"),hi,mi);
	return SS;
}
//---------------------------------------------------------------------------
//saisi la date
void ResetDate()
{
	printf("Entrez la date d'observation (d/m/a)\n");
//	scanf("%d/%d/%d", & date.j, & date.m, & date.a);
// debug
	SYSTEMTIME tmhere;
	GetLocalTime(&tmhere);
	date.j=tmhere.wDay;
	date.m=tmhere.wMonth;
	date.a=tmhere.wYear;
	printf("Date saisie : %d/%d/%d)\n", date.j, date.m, date.a);
}
//---------------------------------------------------------------------------
//saisi l'heure
void ResetHeure()
{
	printf("Entrez l'heure d'observation (h/m/s)\n");
//	scanf("%d/%d/%d", & heure.h, & heure.m, & heure.s);
// debug
	SYSTEMTIME tmhere;
	GetLocalTime(&tmhere);
	heure.s=tmhere.wSecond;
	heure.m=tmhere.wMinute;
	heure.h=tmhere.wHour;
	printf("Date saisie : %d/%d/%d\n", heure.h, heure.m, heure.s);
	heure.ms=0;
}
//---------------------------------------------------------------------------
// 		 ex	TFormMain
//---------------------------------------------------------------------------
void init()
{
	Verbose=true;
	// initialisation...
	ReadConfigFile();
//	printf("Recupre la date du systme ?\n");
	ResetDate();
	ResetHeure();
//	printf("Date : %d/%d/%d\n", date.j, date.m, date.a);
}
//---------------------------------------------------------------------------
void ComputeZuhrHour()
{
double Z_GMT, GMST0;
TCHAR LSS[SSlenght];
	T=JulianCentury (date.j, date.m, date.a, 12);    // pour 12h
	if (Verbose)	printf("T=%g  JC  12h GMT\n",T);
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	theta0=TempsSideral( T);
	GMST0=theta0-heure2rd(12);
	Z_GMT=rd2heure(Soleil.RA-GMST0-longitude);
// iteration bis
	if (Z_GMT<0) 	{// si ngatif, on se place  j-1
								Z_GMT+=24;
								T=JulianCentury (date.j-1, date.m, date.a, Z_GMT+24);    // pour LA vraie heure  GWT
								}
		else				T=JulianCentury (date.j, date.m, date.a, Z_GMT);    // pour LA vraie heure  GWT
	if (Verbose)	printf("T=%g JC  %s\n",T, Lh2hminsec(Z_GMT, LSS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	theta0=TempsSideral( T);
	GMST0=theta0-heure2rd(Z_GMT);
	SalatTime.Zuhr=TimeZone+rd2heure(Soleil.RA-GMST0-longitude);    // on le prend avec TimeZone
	if (SalatTime.Zuhr<0) SalatTime.Zuhr+=24;
}
//---------------------------------------------------------------------------
//compute pour une des 5 prieres
int ComputeTwilightHour(int TypeSalat, double & SalatHour)
{
double costau;
int Offset;
TCHAR LSS[SSlenght];
	SalatHour=0;
	switch (TypeSalat)
		{
		case idFajr : Soleil.h=-SalatTimeConfig[Convention].FajrTwilightAngle*deg2rd;
									Offset=-1;
									break;
		case idIsha : Soleil.h=-SalatTimeConfig[Convention].IshaTwilightAngle*deg2rd;
									Offset=+1;
									break;
		case idChourouk : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=-1;
									break;
		case idMaghrib : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=+1;
									break;
		}
	// commence par calculer au milieur de la journe le T et declinaison du soleil
	// iteration 1
	if (Verbose)	printf(" 1st iter %s\n", Lh2hminsec(SalatTime.Zuhr-TimeZone, LSS));
	T=JulianCentury (date.j, date.m, date.a, SalatTime.Zuhr-TimeZone);    // pour LA vraie heure  GWT
	if (Verbose)		printf("T=%g JC  %s\n", T, Lh2hminsec(SalatTime.Zuhr-TimeZone, LSS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													Offset=+1;
													}
	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau)/SolarSiderealCorrection;
			SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, Lh2hminsec(SalatHour, LSS));
			}
// corrected values, avec iterations
	if (Verbose)	printf("** corrected values ** :\n");
	// iteration 2
	if (Verbose)	printf(" 2nd iter  %s\n", Lh2hminsec(SalatHour-TimeZone, LSS));
	T=JulianCentury (date.j, date.m, date.a, SalatHour-TimeZone);    // pour LA vraie heure  GWT
	if (Verbose)	printf("T=%g JC  %s\n", T, Lh2hminsec(SalatHour-TimeZone, LSS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd(SalatHour-TimeZone);
 	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, Lh2hminsec(SalatHour, LSS));
			}
	// iteration 3
	if (Verbose)	printf(" 3rd iter  %s\n", Lh2hminsec(SalatHour-TimeZone, LSS));
	T=JulianCentury (date.j, date.m, date.a, SalatHour-TimeZone);    // pour LA vraie heure  GWT
	if (Verbose)	printf("T=%g JC  %s\n", T, Lh2hminsec(SalatHour-TimeZone, LSS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													if (Verbose)	printf("h=%g  ie altitude %g\n", Soleil.h*rd2deg, Lrd2degminsec(Soleil.h, LSS));
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd(SalatHour-TimeZone);
	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, Lh2hminsec(SalatHour, LSS));
			}
	return 0;
}
//---------------------------------------------------------------------------
//Appelle les 2 methodes prcdentes pour calculer ttes les prieres
void ComputeSalatTime()
{
int erreur;
TCHAR LSS[SSlenght], LSS2[SSlenght];
	// deja entre date=GetDate();
bool DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) TimeZone=1+TimeZoneTown;
						else  TimeZone=TimeZoneTown;
	if (Verbose)	printf("_____________________________________________________________\n");
	if (Verbose) 	printf("Lieu : %s, %s\n",Towns[TownSelected]->CountryName, Towns[TownSelected]->TownName);
	if (Verbose) 	printf("latitude=%s   longitude=%s\n", Lrd2degminsec(latitude, LSS),Lrd2degminsec(longitude, LSS2));
	if (Verbose) 	printf((DSTApplies ? "DST Applies": "DST does not apply\n"));
	if (Verbose) 	printf("Convention %d\n", Convention);
	if (Verbose)	printf("____ Mawakit Salat _____\n");
	if (Verbose)	printf(" at Date=: %d/%d/%d   TZ=%d\n", date.j, date.m, date.a, TimeZone);
	// Calcul Zuhr
	ComputeZuhrHour();
	if (Verbose)	printf("Passage au mridien (Zuhr)=%gh ie : %s\n", SalatTime.Zuhr, Lh2hminsec(SalatTime.Zuhr, LSS));
	if (Verbose)	printf("\n");
	// lever / coucher
	if (Verbose)	printf("Sunrise / Sunset at -%g", SalatTimeConfig[Convention].Sunrise_setAngle);
	// Calcul Chourouk (lever)
	erreur=ComputeTwilightHour( idChourouk, SalatTime.Chourouk);
	if (Verbose)	printf("Chourouk (Sunrise) at %gh ie : %s\n", SalatTime.Chourouk, Lh2hminsec(SalatTime.Chourouk, LSS));
	if (Verbose)	printf("\n");
	// Calcul Maghrib (coucher)
	erreur=ComputeTwilightHour( idMaghrib, SalatTime.Maghrib);
	if (Verbose)	printf("Maghrib (Sunset) at %gh ie : %s\n", SalatTime.Maghrib, Lh2hminsec(SalatTime.Maghrib, LSS));
	if (Verbose)	printf("\n");
	// Calcul Fajr (Twilight)
	erreur=ComputeTwilightHour( idFajr, SalatTime.Fajr);
	if (Verbose)	printf("Fajr (Twilight) at %gh ie : %s\n", SalatTime.Fajr, Lh2hminsec(SalatTime.Fajr, LSS));
	if (Verbose)	printf("\n");
	// Calcul Isha (Twilight) or Maghrib+
	if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus)
						SalatTime.Isha=SalatTime.Maghrib + SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min/60.0;
			else	erreur=ComputeTwilightHour( idIsha, SalatTime.Isha);
	if (Verbose)	{
								if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus)
											printf("Isha (Maghrib_plus %dmn) at %gh ie : %s\n", SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min, SalatTime.Isha, Lh2hminsec(SalatTime.Isha, LSS));
											else printf("Isha (Twilight) at %gh ie : %s\n", SalatTime.Isha, Lh2hminsec(SalatTime.Isha, LSS));
								}
	if (Verbose)	printf("\n");
	// Calcul Asr (arccot(1+tan(B-D)))
	erreur=ComputeTwilightHour( idAsr, SalatTime.Asr);
	if (Verbose)	printf("Asr (%s) at %gh ie : %s\n", SalatTimeConfig[Convention].AsrShafi>=0 ? "Shafi":"Hanafi", SalatTime.Asr, Lh2hminsec(SalatTime.Asr, LSS));
	if (Verbose)	printf("\n");

	// calcule les vraies heures de prire
	SalatTimeC.Fajr=SalatTime.Fajr +SalatTimeConfig[Convention].SalatTimeAdjust.Fajr/60.0;
	SalatTimeC.Chourouk=SalatTime.Chourouk +SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk/60.0;
	if (SalatTimeConfig[Convention].ZuhrFixe)	SalatTimeC.Zuhr=SalatTimeConfig[Convention].ZuhrFixeHour;
			else SalatTimeC.Zuhr=SalatTime.Zuhr +SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr/60.0;
	SalatTimeC.Asr=SalatTime.Asr +SalatTimeConfig[Convention].SalatTimeAdjust.Asr/60.0;
	SalatTimeC.Maghrib=SalatTime.Maghrib +SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib/60.0;
	SalatTimeC.Isha=SalatTime.Isha  +SalatTimeConfig[Convention].SalatTimeAdjust.Isha/60.0;
	if (Verbose)	printf("_______ Mawakit Salat Exactes _______\n");
	if (Verbose)	printf("Fajr    =%s%s%gmn  %s\n", Lh2hminsec(SalatTime.Fajr, LSS), SalatTimeConfig[Convention].SalatTimeAdjust.Fajr>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, Lh2hminsec(SalatTimeC.Fajr, LSS2));
	if (Verbose)	printf("Chourouk=%s%s%gmn  %s\n", Lh2hminsec(SalatTime.Chourouk, LSS), SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk, Lh2hminsec(SalatTimeC.Chourouk, LSS2));
	if (Verbose)	{
								if (SalatTimeConfig[Convention].ZuhrFixe)	printf("Zuhr Fixed = %s\n", Lh2hminsec(SalatTimeC.Zuhr, LSS));
									else printf("Zuhr    =%s%s%gmn  %s\n", Lh2hminsec(SalatTime.Zuhr, LSS), SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, Lh2hminsec(SalatTimeC.Zuhr, LSS2));
								}
	if (Verbose)	printf("Asr     =%s%s%gmn  %s\n", Lh2hminsec(SalatTime.Asr, LSS), SalatTimeConfig[Convention].SalatTimeAdjust.Asr>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Asr, Lh2hminsec(SalatTimeC.Asr, LSS2));
	if (Verbose)	printf("Maghrib =%s%s%gmn  %s\n", Lh2hminsec(SalatTime.Maghrib, LSS), SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, Lh2hminsec(SalatTimeC.Maghrib, LSS2));
	if (Verbose)	printf("Isha    =%s%s%gmn  %s\n", Lh2hminsec(SalatTime.Isha, LSS), SalatTimeConfig[Convention].SalatTimeAdjust.Isha>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Isha, Lh2hminsec(SalatTimeC.Isha, LSS2));
	if (Verbose)	printf("_______ Mawakit Salat arrondi _______\n");

	if (Verbose) 	printf("Lieu : %s, %s\n",Towns[TownSelected]->CountryName, Towns[TownSelected]->TownName);
	if (Verbose) 	printf("latitude=%s   longitude=%s Convention %d\n", Lrd2degminsec(latitude, LSS), Lrd2degminsec(longitude, LSS2), Convention);
	if (Verbose)	printf("__ Date : %s %d/%d/%d   %s  TZ (include DST)=%d\n", Days[CalculeJour(T+(TimeZone+12)/24.0/36525.0)], date.j, date.m, date.a,
																																DSTApplies ? "DST Applies": "DST does not apply", TimeZone);
	if (Verbose)	printf("Fajr    =%s\n", Lh2hmiarrondie(SalatTimeC.Fajr, LSS));
	if (Verbose)	printf("Chourouk=%s\n", Lh2hmiarrondie(SalatTimeC.Chourouk, LSS));
	if (Verbose)	printf("Zuhr    =%s\n", Lh2hmiarrondie(SalatTimeC.Zuhr, LSS));
	if (Verbose)	printf("Asr     =%s\n", Lh2hmiarrondie(SalatTimeC.Asr, LSS));
	if (Verbose)	printf("Maghrib =%s\n", Lh2hmiarrondie(SalatTimeC.Maghrib, LSS));
	if (Verbose)	printf("Isha    =%s\n", Lh2hmiarrondie(SalatTimeC.Isha, LSS));
	if (Verbose)	printf("_____________________________________\n");
}
//---------------------------------------------------------------------------
void ButtonCalc_hazClick()
{
TCHAR LSS[SSlenght], LSS2[SSlenght];
// deja entre 	ou mieux date=GetDate();
	// ResetHeure(); // ou plutot get : elle y est deja
 // debug
bool DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) TimeZone=1+TimeZoneTown;
						else  TimeZone=TimeZoneTown;
	if (Verbose)	printf("_____________________________________________________________\n");
	if (Verbose) 	printf("Lieu : %s, %s\n",Towns[TownSelected]->CountryName, Towns[TownSelected]->TownName);
	if (Verbose) 	printf("latitude=%g   longitude=%g\n", latitude*rd2deg, longitude*rd2deg);
	if (Verbose) 	printf("latitude=%s   longitude=%s\n", Lrd2degminsec(latitude, LSS), Lrd2degminsec(longitude, LSS2));
//???  if (date.j<0) {date.j+=???; date.m--}
	date.h=heure.h-TimeZone+heure.m/60.0+heure.s/3600.0;
	if (date.h<0) {date.h+=24; date.j--;}
// debug  fin
	if (Verbose)	printf("__ Date : %s %d/%d/%d  %gh UT   %s  TZ (include DST)=%d\n", Days[CalculeJour(T+(TimeZone+12)/24.0/36525.0)], date.j, date.m, date.a,
																									date.h, DSTApplies ? "DST Applies": "DST does not apply", TimeZone);

	T=JulianCentury (date.j, date.m, date.a, date.h);
	if (Verbose)	printf("T=%g JC\n",T);

	Soleil.L=SoleilLongitude(T);
	if (Verbose) printf("Soleil Longitude L=%g ie : %s\n", Soleil.L*rd2deg, Lrd2hminsec(Soleil.L, LSS));
  eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
  theta0=TempsSideral( T);
	theta=theta0+longitude;
	if (Verbose) printf("theta0=%g ie : %s\n", theta0*rd2deg, Lrd2hminsec(theta0, LSS));
	if (Verbose) printf("theta=%g  ie heure sidrale %s\n", theta*rd2deg, Lrd2hminsec(theta, LSS));
	Soleil.tau=theta-Soleil.RA;
	if (Verbose) printf("RA=%g ie : %s\n", Soleil.RA*rd2deg, Lrd2hminsec(Soleil.RA, LSS));
	if (Verbose) printf("delta=%g  ie DE %s\n", Soleil.delta*rd2deg, Lrd2degminsec(Soleil.delta, LSS));
	if (Verbose) printf("tau=%g  ie angle horaire %s\n", Soleil.tau*rd2deg, Lrd2hminsec(Soleil.tau, LSS));
	equatorial2horizontal( latitude, Soleil.tau, Soleil.delta, Soleil.h, Soleil.az);
	if (Verbose) printf("az=%g (orgine Sud) ie : azimut %s\n", Soleil.az*rd2deg, Lrd2degminsec(Soleil.az, LSS));
	if (Verbose) printf("------az=%g (orgine Nord) ie -180 : azimut %s\n", Soleil.az*rd2deg-180, Lrd2degminsec(Soleil.az-M_PI, LSS));
	if (Verbose) printf("h=%g  ie altitude %s\n", Soleil.h*rd2deg, Lrd2degminsec(Soleil.h, LSS));
}
//---------------------------------------------------------------------------
void Oneday1Click()
{
	printf("\n");
	ComputeSalatTime();
}
//---------------------------------------------------------------------------
int ReadConfigFile()
{
TCHAR FileName[]=L"data.cfg";
TCHAR LSS[SSlenght], LSS2[SSlenght];
int iAsr, iIsha_is_Maghrib_plus, iZuhrFixe, TownsCount=0;
TCHAR * p;
TownData * ATown;
FILE * DataFile, * EchoFile;
int Code;
TCHAR Comment[201];
	TCHAR path[256]; 
	TCHAR fullPathFileName[256], fullPathReadEcho[256]; 
	GetModuleFileName(NULL, path, 256);   //returns full path with .exe name 
	TCHAR *pos = wcsrchr(path, '\\');   //gets the last occurrance of '\' 
	*(pos + 1) = '\0'; 
	wcscpy(fullPathFileName, path); 
	wcscat(fullPathFileName, FileName); 
	wcscpy(fullPathReadEcho, path); 
	wcscat(fullPathReadEcho, TEXT("read_echo.cfg")); 

	if( (DataFile=_wfopen( fullPathFileName, L"r")) == NULL )
				{
				//STLOG_WRITE(L"Cannot open data.cfg file");
				//STLOG_LASTERROR;
				 MessageBox(NULL, fullPathFileName, TEXT("File open error"), MB_OK);
				 return 1;
				 }
	if( (EchoFile=_wfopen( fullPathReadEcho, TEXT("w"))) == NULL )
				{
				MessageBox(NULL, fullPathReadEcho, TEXT("File open error"), MB_OK);
				return 2;
				}
	fwprintf(EchoFile,L"%s\n", L"8 -----------------  File reading transcription  ---------------");
	while ( fscanf(DataFile,"%d", & Code) !=EOF)
	{
//	if (::GetAsyncKeyState(VK_ESCAPE) & 0x8000 ) 	break;
										// ie sort de la boucle
	fwprintf(EchoFile, L"%d ", Code);

	switch ( Code)
	 {
//8 - Conventions
//8 Convention Name
	case 5 :
		fwscanf( DataFile, TEXT("%d"), & Convention);
		fgetws( Comment, 200, DataFile);
		p=wcstok(Comment,TEXT("\""));
		p=wcstok(NULL,TEXT("\""));
		wcscpy( SalatTimeConfig[Convention].Name, wcstok(p,TEXT("\"")));
		fwprintf(EchoFile, TEXT("%-9d \"%s\"\n"), Convention, SalatTimeConfig[Convention].Name);
		break;
//8 Convention AsrSahfi/Hanafi FajrTwilightAngle IshaTwilightAngle Sunrise/SetAngle Isha_is_Maghrib_plus xx mn ZuhrFixe ZuhrHour(h)
	case 3 :
		fwscanf( DataFile,TEXT("%d"), & Convention);
		fwscanf( DataFile,TEXT("%d %lf %lf %lf %d %d %d %lf\n"), & iAsr, & SalatTimeConfig[Convention].FajrTwilightAngle, & SalatTimeConfig[Convention].IshaTwilightAngle,
								& SalatTimeConfig[Convention].Sunrise_setAngle,
								& iIsha_is_Maghrib_plus, & SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min,
								& iZuhrFixe, & SalatTimeConfig[Convention].ZuhrFixeHour);
		fwprintf(EchoFile, TEXT("%-9d  %-14d  %-16g  %-16g  %-15g  %-19d  %-4d  %-7d  %-15.7f\n"), Convention, iAsr,
						SalatTimeConfig[Convention].FajrTwilightAngle, SalatTimeConfig[Convention].IshaTwilightAngle,
						SalatTimeConfig[Convention].Sunrise_setAngle,
						iIsha_is_Maghrib_plus, SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min,
						iZuhrFixe, SalatTimeConfig[Convention].ZuhrFixeHour);
		SalatTimeConfig[Convention].AsrShafi=(iAsr==1);
		SalatTimeConfig[Convention].Isha_is_Maghrib_plus=(iIsha_is_Maghrib_plus==1);
		SalatTimeConfig[Convention].ZuhrFixe=(iZuhrFixe==1);
		break;
//- Time (mn) to add to get Salat
//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	case 4 :
		fwscanf( DataFile,TEXT("%d"), & Convention);
		fwscanf( DataFile,TEXT("%lf %lf %lf %lf %lf %lf\n"), & SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, & SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk,
						& SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, & SalatTimeConfig[Convention].SalatTimeAdjust.Asr,
						& SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, & SalatTimeConfig[Convention].SalatTimeAdjust.Isha);
		fwprintf(EchoFile, TEXT("%-9d  %-7g  %-7g  %-7g  %-7g  %-7g  %-7g\n"), Convention, SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk,
						SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, SalatTimeConfig[Convention].SalatTimeAdjust.Asr,
						SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, SalatTimeConfig[Convention].SalatTimeAdjust.Isha);
		break;
//8 NumberOfTowns  TownSelected  Verbose
	case 1 :
		fwscanf( DataFile,TEXT("%d %d %d\n"), & NTowns, & TownSelected, & Verbose);
		fwprintf(EchoFile, TEXT("%-13d  %-12d  %-7d\n"), NTowns, TownSelected, Verbose);
		if (NTowns<=0) {
					MessageBox(NULL, TEXT("Invalid number of towns in data.cfg"), TEXT("Read error"), MB_OK);
					return 6;
					}
//		if (Towns!=NULL)	delete[] Towns;
		Towns=new pTownData[NTowns];
		break;
//8 - Town location and TimeZone
//8 Country   Name            latitude   longitude TimeZone DST
	case 2 :
		ATown=new TownData;
		fwscanf( DataFile,L"%s %s %lf %lf %d %d %d\n", & ATown->CountryName, & ATown->TownName,
						& ATown->latitude, & ATown->longitude,
						& ATown->TimeZoneTown, & ATown->DST, & ATown->Convention);
		fwprintf(EchoFile, L"%-15s  %-15s  %-10lf  %-10lf  %-7d  %-2d  %-2d\n", ATown->CountryName, ATown->TownName,
						ATown->latitude, ATown->longitude,
						ATown->TimeZoneTown, ATown->DST, ATown->Convention);
		Towns[TownsCount]=ATown;
		TownsCount++;
		break;
// Commentaire
	 case 8 :
		fgetws( Comment, 200, DataFile);
		long curpos;
		curpos = ftell(EchoFile);
		fseek(EchoFile, curpos-1, SEEK_SET);
		fwprintf(EchoFile, L"%s", Comment);
		break;

		default :
		MessageBox(NULL, TEXT("bad format of data.cfg"), TEXT("Read error"), MB_OK);
		return 3;
		}   // switch

	}  // while
	fclose( DataFile);
	// Ferme aussi le fichier de sortie rd_echo.dat
	fclose( EchoFile);
	if (NTowns != TownsCount) {
				MessageBox(NULL, TEXT("Number of towns does not match NTowns"), TEXT("Read error"), MB_OK);
				return 4;
				}

//ajouter aus Items de Listes des 2 form dialog
//	FormTowns->LBConvention->Items->Clear();
//	FormSettings->LBConvention->Items->Clear();
//	for (i=0; i<NConvention; i++)
//		{
//		FormTowns->LBConvention->Items->Add(SalatTimeConfig[i].Name);
//		FormSettings->LBConvention->Items->Add(SalatTimeConfig[i].Name);
//		}

	if (TownSelected>=0 && TownSelected<NTowns) {
									wcscpy( CountryName, Towns[TownSelected]->CountryName);
									wcscpy( TownName, Towns[TownSelected]->TownName);
									longitude=deg2rd*Towns[TownSelected]->longitude;
									latitude=deg2rd*Towns[TownSelected]->latitude;
									TimeZoneTown=Towns[TownSelected]->TimeZoneTown;
									DST=Towns[TownSelected]->DST;
									Convention=Towns[TownSelected]->Convention;
									if (Verbose) wprintf(L"Lieu actuel : \n");
									if (Verbose) 	wprintf(L"Lieu : %s, %s\n",Towns[TownSelected]->CountryName, Towns[TownSelected]->TownName);
									if (Verbose) 	wprintf(L"latitude=%s   longitude=%s\n", Lrd2degminsec(latitude, LSS), Lrd2degminsec(longitude, LSS2));
									if (Verbose) 	wprintf(L"Convention %d\n", Convention);
									}
				else			{
									wprintf(L"Error : Selected town out of range");
									return 5;
									}
}
//---------------------------------------------------------------------------
void WriteConfigFile()
{
FILE * DataFile;
int i;
TCHAR path[256]; 
TCHAR fullPathFileName[256]; 
	GetModuleFileName(NULL, path, 256);   //returns full path with .exe name 
	TCHAR *pos = wcsrchr(path, '\\');   //gets the last occurrance of '\' 
	*(pos + 1) = '\0'; 
	wcscpy(fullPathFileName, path); 
	wcscat(fullPathFileName, L"data.cfg"); 
	if( (DataFile=_wfopen( fullPathFileName, L"w")) == NULL )
			{
			MessageBox(NULL, fullPathFileName, TEXT("File open error for writing data.cfg"), MB_OK);
			return;
			}
	fwprintf(DataFile,L"8 ------------------------------------------------------------------\n");
	fwprintf(DataFile,L"8 --------- Config file for Salat and Sun position program ---------\n");
	fwprintf(DataFile,L"8 ------------------------------------------------------------------\n");
	for (i=0; i<NConvention; i++)
		{
		fwprintf(DataFile,L"8 Convention Name\n");
		fwprintf(DataFile, L"5 %-9d \"%s\"\n", i, SalatTimeConfig[i].Name);
		fwprintf(DataFile,L"8 Convention AsrSahfi/Hanafi FajrTwilightAngle IshaTwilightAngle Sunrise/SetAngle Isha_is_Maghrib_plus xx mn ZuhrFixe ZuhrHour(h)\n");
		fwprintf(DataFile, L"3 %-9d  %-14d  %-16g  %-16g  %-15g  %-19d  %-4d  %-7d  %-15.7f\n", i, (SalatTimeConfig[i].AsrShafi ? 1:0),
						SalatTimeConfig[i].FajrTwilightAngle, SalatTimeConfig[i].IshaTwilightAngle,
						SalatTimeConfig[i].Sunrise_setAngle,
						(SalatTimeConfig[i].Isha_is_Maghrib_plus ? 1:0), SalatTimeConfig[i].Isha_is_Maghrib_plus_min,
						(SalatTimeConfig[i].ZuhrFixe ? 1:0), SalatTimeConfig[i].ZuhrFixeHour);
		fwprintf(DataFile,L"8 - Time (mn) to add to get Salat\n");
		fwprintf(DataFile,L"8 Convention Fajr     Chourouk Zuhr     Asr      Maghrib  Isha\n");
		fwprintf(DataFile, L"4 %-9d  %-7g  %-7g  %-7g  %-7g  %-7g  %-7g\n", i, SalatTimeConfig[i].SalatTimeAdjust.Fajr, SalatTimeConfig[i].SalatTimeAdjust.Chourouk,
						SalatTimeConfig[i].SalatTimeAdjust.Zuhr, SalatTimeConfig[i].SalatTimeAdjust.Asr,
						SalatTimeConfig[i].SalatTimeAdjust.Maghrib, SalatTimeConfig[i].SalatTimeAdjust.Isha);
		fwprintf(DataFile,L"8 ------------------------------------------------------------------\n");
		}
	fwprintf(DataFile,L"8 - sources :\n");
	fwprintf(DataFile,L"8 - http://www.ummah.net/astronomy/saltime/\n");
	fwprintf(DataFile,L"8 - http://moonsighting.com/faq_pt.html#F1\n");
	fwprintf(DataFile,L"8 - http://stjarnhimlen.se/comp/riset.html#3\n");
	fwprintf(DataFile,L"8 - http://www.jgiesen.de/SME/details/basics/meeus.htm#solar\n");
	fwprintf(DataFile,L"8 - http://www.fallingrain.com/world\n");
	fwprintf(DataFile,L"8 - http://maps.google.com/\n");
	fwprintf(DataFile,L"8 ------------------------------------------------------------------\n");
	fwprintf(DataFile,L"8 NumberOfTowns  TownSelected  Verbose\n");
	fwprintf(DataFile, L"1 %-13d  %-12d  %-7d\n", NTowns, TownSelected, Verbose);
	if (NTowns<=0) {
				MessageBox(NULL, TEXT("Invalid number of towns in data.cfg"), TEXT("Read error"), MB_OK);
				}
	fwprintf(DataFile,L"8 ------------------------------------------------------------------\n");
	fwprintf(DataFile,L"8 - Town location and TimeZone\n");
	fwprintf(DataFile,L"8 Country          Name             latitude    longitude   TimeZone DST Convention\n");
	for (i=0; i<NTowns; i++)
		{
		fwprintf(DataFile, L"2 %-15s  %-15s  %-10lf  %-10lf  %-7d  %-2d  %-2d\n", Towns[i]->CountryName, Towns[i]->TownName,
						Towns[i]->latitude, Towns[i]->longitude,
						Towns[i]->TimeZoneTown, Towns[i]->DST, Towns[i]->Convention);
		}
	fwprintf(DataFile,L"8 ------------------------------------------------------------------\n");
	fclose( DataFile);
}
//---------------------------------------------------------------------------
void Saveconfiguration1Click()
{
	WriteConfigFile();
}
/*
//---------------------------------------------------------------------------
void Settings1Click()
{
	FormSettings->RGAsr->ItemIndex=(SalatTimeConfig[Convention].AsrShafi ? 0:1);
	FormSettings->EditSunrise_setAngle->Text=SalatTimeConfig[Convention].Sunrise_setAngle;
	FormSettings->EditFajrTwilightAngle->Text=SalatTimeConfig[Convention].FajrTwilightAngle;
	FormSettings->EditIshaTwilightAngle->Text=SalatTimeConfig[Convention].IshaTwilightAngle;
	FormSettings->LBConvention->ItemIndex=Convention;
	FormSettings->CBIsha_is_Maghrib->Checked=SalatTimeConfig[Convention].Isha_is_Maghrib_plus;
	FormSettings->EditIsha_is_Maghrib_plus->Text=SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min;
	FormSettings->CBZuhrFixe->Checked = SalatTimeConfig[Convention].ZuhrFixe;
	FormSettings->TPZuhrFixeHour->Time = SalatTimeConfig[Convention].ZuhrFixeHour/24.0;

	FormSettings->VLEtime2add4salat->Strings->ValueFromIndex[idFajr]=SalatTimeConfig[Convention].SalatTimeAdjust.Fajr;
	FormSettings->VLEtime2add4salat->Strings->ValueFromIndex[idChourouk]=SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk;
	FormSettings->VLEtime2add4salat->Strings->ValueFromIndex[idZuhr]=SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr;
	FormSettings->VLEtime2add4salat->Strings->ValueFromIndex[idAsr]=SalatTimeConfig[Convention].SalatTimeAdjust.Asr;
	FormSettings->VLEtime2add4salat->Strings->ValueFromIndex[idMaghrib]=SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib;
	FormSettings->VLEtime2add4salat->Strings->ValueFromIndex[idIsha]=SalatTimeConfig[Convention].SalatTimeAdjust.Isha;
	FormSettings->ShowModal();
}
//---------------------------------------------------------------------------
void TownsConfigClick()
{
int i;
// http://www.mapsofworld.com/lat_long/algeria-lat-long.html
	FormTowns->CBTowns->Items->Clear();
	for(i=0; i<NTowns; i++)
		FormTowns->CBTowns->Items->Add(Towns[i]->CountryName+" : "+Towns[i]->TownName);
	FormTowns->CBTowns->ItemIndex=TownSelected;
	FormTowns->IDC_longitude->Text=Towns[TownSelected]->longitude;
	FormTowns->CBlongitude->ItemIndex=(Towns[TownSelected]->longitude>=0 ? 0:1);
	FormTowns->IDC_latitude->Text=Towns[TownSelected]->latitude;
	FormTowns->CBlatitude->ItemIndex=(Towns[TownSelected]->latitude>=0 ? 0:1);
	FormTowns->CBTimeZoneTown->ItemIndex=Towns[TownSelected]->TimeZoneTown+12;
	FormTowns->RGDST->ItemIndex=Towns[TownSelected]->DST;
	FormTowns->LBConvention->ItemIndex=Towns[TownSelected]->Convention;
	FormTowns->EditCountryName->Text= Towns[TownSelected]->CountryName;
	FormTowns->EditTownName->Text= Towns[TownSelected]->TownName;
	if (FormTowns->ShowModal()==ID_OK)
			{
			if (FormTowns->CBTowns->ItemIndex==-1) return;
			TownSelected=FormTowns->CBTowns->ItemIndex;
			longitude=deg2rd*Towns[TownSelected]->longitude;
			latitude=deg2rd*Towns[TownSelected]->latitude;
			TimeZoneTown=Towns[TownSelected]->TimeZoneTown;
			DST=Towns[TownSelected]->DST;
			Convention=Towns[TownSelected]->Convention;
			}
}
*/
//---------------------------------------------------------------------------
int CalculeNjdumois(int m, int annee)
{
int Nonbissextile=(annee-4*(int)(annee/4)+2)/3;  // 1 pour une anne commune et  0 pour une bissextile)
	if (m==1 || m==3 || m==5 || m==7
	 || m==8 || m==10 || m==12) 	return 31;
			else	{
						if (m==2) {if (Nonbissextile) return 28;
															else				return 29;
											}
								else  return 30;
				}
}
//---------------------------------------------------------------------------
int CalculeJour(double T) //  pertir du siecle Julien
{
double jour=T*36525+5;   
	return jour-7*(int)(jour/7);
}
//---------------------------------------------------------------------------
void OnemounthCalculate(SalatTimeStruct * CalMensuel, int * daysMensuel, int Nj)
{
bool DSTApplies;
int erreur;
DateUT dateSave=date;
		for (date.j=1; date.j<=Nj; date.j++)
			{
			// dbut du calcul des SalatTime pour un jour
			DSTApplies=DST && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
			if (DSTApplies) TimeZone=1+TimeZoneTown;
								else  TimeZone=TimeZoneTown;
			// Calcul salat hour of the Day date.j
			ComputeZuhrHour();
			daysMensuel[date.j-1]=CalculeJour(T+(TimeZone+12)/24.0/36525.0);  // juste pour le jour (Lundi, mardi...)
			erreur=ComputeTwilightHour( idChourouk, SalatTime.Chourouk);
			erreur=ComputeTwilightHour( idMaghrib, SalatTime.Maghrib);
			erreur=ComputeTwilightHour( idFajr, SalatTime.Fajr);
			if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus)
								SalatTime.Isha=SalatTime.Maghrib + SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min/60.0;
					else	erreur=ComputeTwilightHour( idIsha, SalatTime.Isha);
			erreur=ComputeTwilightHour( idAsr, SalatTime.Asr);

			// calcule les vraies heures de prire
			SalatTimeC.Fajr=SalatTime.Fajr +SalatTimeConfig[Convention].SalatTimeAdjust.Fajr/60.0;
			SalatTimeC.Chourouk=SalatTime.Chourouk +SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk/60.0;
			if (SalatTimeConfig[Convention].ZuhrFixe)	SalatTimeC.Zuhr=SalatTimeConfig[Convention].ZuhrFixeHour;
					else SalatTimeC.Zuhr=SalatTime.Zuhr +SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr/60.0;
			SalatTimeC.Asr=SalatTime.Asr +SalatTimeConfig[Convention].SalatTimeAdjust.Asr/60.0;
			SalatTimeC.Maghrib=SalatTime.Maghrib +SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib/60.0;
			SalatTimeC.Isha=SalatTime.Isha  +SalatTimeConfig[Convention].SalatTimeAdjust.Isha/60.0;
			// fin du calcul pour un jour
			CalMensuel[date.j-1].Fajr=SalatTimeC.Fajr;
			CalMensuel[date.j-1].Chourouk=SalatTimeC.Chourouk;
			CalMensuel[date.j-1].Zuhr=SalatTimeC.Zuhr;
			CalMensuel[date.j-1].Asr=SalatTimeC.Asr;
			CalMensuel[date.j-1].Maghrib=SalatTimeC.Maghrib;
			CalMensuel[date.j-1].Isha=SalatTimeC.Isha;
			}
	date=dateSave;
}
//---------------------------------------------------------------------------
void Onemounth1Click()
{
DateUT dateSave=date;
TCHAR path[256]; 
TCHAR FileName[Namelenght], fullPathFileName[256]; 
wchar_t LfullPathFileName[256];
FILE * OutFile;
TCHAR LSS[6][SSlenght];
bool SaveVerbose, Pair;
int erreur, Nj;
SalatTimeStruct CalMensuel[31];		// on est sr d'tre en dessous de 31 j ;-)
int	daysMensuel[31];
// debug  saisir	date=GetDate();
	Nj=CalculeNjdumois( date.m, date.a);
	SaveVerbose=Verbose;
	Verbose=false;
	OnemounthCalculate( CalMensuel , daysMensuel, Nj);  // calcul les heures et le stocke
	Verbose=SaveVerbose;
	// cree entete fichier html
	GetModuleFileName(NULL, path, 256);   //returns full path with .exe name 

	TCHAR *pos = wcsrchr(path, '\\');   //gets the last occurrance of '\' 
	*(pos + 1) = TEXT('\0'); 
	wcscpy(fullPathFileName, path); 
	wsprintf(FileName, L"%s_%s%d.html", Towns[TownSelected]->TownName, Mounths[date.m-1], date.a);
	wcscat(fullPathFileName, FileName); 
	if( (OutFile=_wfopen( fullPathFileName, L"w")) == NULL )
			{
			printf( "File open error %s\n", FileName);
			return;
      }
fwprintf(OutFile, L"<html><!-- Generateur de calendrier de prires - %s %d -->\n", Mounths[date.m-1], date.a);
fwprintf(OutFile, L"<head>\n");
fwprintf(OutFile, L"		<title>Calendrier de prires - %s %d </title>\n", Mounths[date.m-1], date.a);
fwprintf(OutFile, L"		<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\"/>\n");
fwprintf(OutFile, L"		<link rel=\"stylesheet\" href=\"style.css\" type=\"text/css\" />\n");
fwprintf(OutFile, L"	</head>\n	<body>\n");

fwprintf(OutFile, L"<b> Calendrier de prires - %s %d<br/>Lieu : %s, %s - </b>Generated by SalatTime (c)\n",
									Mounths[date.m-1], date.a, Towns[TownSelected]->CountryName, Towns[TownSelected]->TownName);
fwprintf(OutFile, L"			<table cellpadding=0 cellspacing=1 border=1 class=tb>\n");
fwprintf(OutFile, L"<tr bgcolor=\"#00F0F0\">\
			<td width=10></td> \
			<td width=60><b> Jour </b></td> \
			<td width=40><b> Fajr </b></td>\
			<td width=40><b> Chourouk</b></td>\
			<td width=40><b> Zuhr </b></td>\
			<td width=40><b> Asr </b></td>\
			<td width=40><b> Maghrib </b></td>\
			<td width=40><b> Isha</b></td> </tr>\n");
	for (date.j=1; date.j<=Nj; date.j++)
		{
		if (date.j/2==date.j/2.0)	Pair=true;
			else Pair=false;
		if (daysMensuel[date.j-1]==4) fwprintf(OutFile, L"<tr bgcolor=\"#FFD5D5\">\n");
			else 	{
						if (Pair)
								fwprintf(OutFile, L"<tr bgcolor=\"#F5F5F5\">\n");
								else
								fwprintf(OutFile, L"<tr bgcolor=\"#F0F0E0\">\n");
						}
		fwprintf(OutFile, L"\
		<td width=10 align=\"right\"><b>%2d</b></td> \
		<td width=60><b>%s</b></td> \
		<td width=40>&nbsp;%s</td>\
		<td width=40>&nbsp;%s</td>\
		<td width=40>&nbsp;%s</td>\
		<td width=40>&nbsp;%s</td>\
		<td width=40>&nbsp;%s</td>\
		<td width=40>&nbsp;%s</td></tr>\n",\
		date.j,Days[daysMensuel[date.j-1]],\
		Lh2hmiarrondie(CalMensuel[date.j-1].Fajr, LSS[0]), Lh2hmiarrondie(CalMensuel[date.j-1].Chourouk, LSS[1]),\
		Lh2hmiarrondie(CalMensuel[date.j-1].Zuhr, LSS[2]), Lh2hmiarrondie(CalMensuel[date.j-1].Asr, LSS[3]),\
		Lh2hmiarrondie(CalMensuel[date.j-1].Maghrib, LSS[4]), Lh2hmiarrondie(CalMensuel[date.j-1].Isha, LSS[5]));
		}
fwprintf(OutFile, L"</table><BR>	</body>\n</html>\n");
	fclose( OutFile);
	date=dateSave;
	// call iexplorer
	CreateProcess(TEXT("iexplore.exe"), fullPathFileName, NULL, NULL, FALSE, 0, NULL, NULL, NULL, NULL);
}
//---------------------------------------------------------------------------

void Loadconfiguration1Click()
{
	// re-initialisation...
	ReadConfigFile();
// debug
	printf("Recupre la date du systme ?\n");
	ResetDate();
	printf("Date : %d/%d/%d)\n", date.j, date.m, date.a);
//	DatePicker->DateTime=Now();
//	TimePicker->DateTime=Now();
}
//---------------------------------------------------------------------------

/*
int main(int argc, char* argv[])
{
char a;
	init();
// change town :
	TownSelected=1;    // Nancy
	longitude=deg2rd*((pTownData)(Towns[TownSelected]))->longitude;
	latitude=deg2rd*Towns[TownSelected]->latitude;
	TimeZoneTown=Towns[TownSelected]->TimeZoneTown;
	DST=Towns[TownSelected]->DST;
	Convention=Towns[TownSelected]->Convention;

//	WriteConfigFile();     elle marche
//	Onemounth1Click();
//	Oneyear1Click();

	ComputeSalatTime();
//	ButtonCalc_hazClick();
	scanf("c",&a);
	return 0;
}
*/
//---------------------------------------------------------------------------
