// TodaySalatTime.cpp : Defines the entry point for the DLL application.
// version 1.5 : 04/05/2008 (regitry, Alarams, Blinking)

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include <todaycmn.h>
#include <Notify.h>

#include "maincmddll.h"
#include "resource.h"

#define GET_X_LPARAM(lp)                        ((int)(short)LOWORD(lp))
#define GET_Y_LPARAM(lp)                        ((int)(short)HIWORD(lp))
//#define MAKEPOINTS(l) (*((POINT FAR *) & (l)))

// debug
//SYSTEMTIME tmhereDebug;
//global variables    
HICON               g_hIcon;
HINSTANCE           g_hInst;
HWND                g_hWnd;
bool	VGA;
TCHAR g_szPluginClass[] = TEXT("SalatTimeClass");
DateUT Newdate;
BOOL Refresh, DeuxLignes, SalatBlink[6], Blinking, RefreshCalcRect;	// Chourouk non affich mais pris en compte
int BlinkState, CurrentMinute, SeqAthan;
const int SeqAthanMax=5;
RECT SalatRect[6][2];
TCHAR PrincipaleSS[200];
TCHAR RegKey[] = TEXT ("Software\\Microsoft\\Today\\Items\\SalatTime");
struct SalatAlarms { bool Fajr, Chourouk, Zuhr, Asr, Maghrib, Isha;}
				SalatAlarm;
RECT rcGenerateArea;
struct hNotifySalatStruct  { HANDLE Fajr, Chourouk, Zuhr, Asr, Maghrib, Isha;} hNotifySalat;

void UpdatePrincipaleSS();
LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);

//-------------------------------------------------------------------------
static HRESULT ClearRunApp(LPCTSTR szToCompare)
{
  HRESULT hr = S_OK;
  
  // hold a notification
  PBYTE pBuff = (PBYTE)LocalAlloc(LPTR, 8192);
  
  if (!pBuff) {
    return E_OUTOFMEMORY;
  }
  
  // at most 256 notification handles
  HANDLE hNotifHandlers[256];
  DWORD nNumHandlers, nNumClearedHandlers = 0;
  DWORD i = 0;
  int rc = CeGetUserNotificationHandles(hNotifHandlers, 256, &nNumHandlers);
  if (!rc) {
    hr = E_FAIL;
    goto FuncExit;
  }
  
  // iterate all notifications
  // Notice: We do not care about the status of the notification.
  // Just clear it even if it is not filed??
  for (; i<nNumHandlers; i++) {
    // query info for this specific handler
    BOOL bClearThis = FALSE;
    DWORD dwSize = 0;
    rc = CeGetUserNotification(
    hNotifHandlers[i], 8192, &dwSize, pBuff);
    if (!rc) continue;
    
    PCE_NOTIFICATION_INFO_HEADER pnih = (PCE_NOTIFICATION_INFO_HEADER)pBuff;
    PCE_NOTIFICATION_TRIGGER pNotifTrigger = pnih->pcent;
    // Notice some events with NULL lpszApplication might be inserted!
    if (pNotifTrigger && pNotifTrigger->lpszApplication
      && !_tcsicmp(pNotifTrigger->lpszApplication, szToCompare)) 
				CeClearUserNotification(pnih->hNotification);
  }
 
  FuncExit:
		if (pBuff)	LocalFree(pBuff);  
  return hr;
}
//-------------------------------------------------------------------------
static HRESULT ReleaseUserNotif(HANDLE hNotify)
{
	if (hNotify)	CeClearUserNotification(hNotify);
}
//-------------------------------------------------------------------------
// http://windowsmobilepro.blogspot.com/2005/12/pocket-pc-power-management-series-6.html
// http://windows-ce-dox.net/Prentice.Hall.PTR-Windows.CE.3/WinCE_30/90.htm
static HRESULT SetUserNotif(double SalatTimeHour, HANDLE & hNotify, TCHAR * Eventmsg, TCHAR * msg)
{
  HRESULT hr = S_OK;
  hNotify = NULL;
  // set a CE_NOTIFICATION_TRIGGER
  CE_NOTIFICATION_TRIGGER notifTrigger;
  memset(&notifTrigger, 0, sizeof(CE_NOTIFICATION_TRIGGER));
  notifTrigger.dwSize = sizeof(CE_NOTIFICATION_TRIGGER);
  // calculate time
  SYSTEMTIME st = {0}, et = {0};
  GetLocalTime(&st);
	st.wHour=SalatTimeHour;
	st.wMinute= (SalatTimeHour-st.wHour)*60;
	//st.wSecond+=10;
	st.wSecond=0;
	et=st;	et.wMinute=st.wMinute+1;
	if (et.wMinute==60)	{ et.wMinute=0; et.wHour+=1; }

	notifTrigger.dwType = CNT_PERIOD;	//CNT_TIME;
//notifTrigger.dwEvent = 1; //3 ac on , 4 ac off, 1  time change
  notifTrigger.stStartTime = st;
	notifTrigger.stEndTime = et;
  // timer: execute No application at specified time, but fire a Dialog, vibrate, flash...
  TCHAR LSS[100];
	wsprintf( LSS,  L"\\\\.\\Notifications\\NamedEvents\\%s", Eventmsg);
	notifTrigger.lpszApplication = LSS;
  notifTrigger.lpszArguments = NULL;

  // set a CE_USER_NOTIFICATION
  CE_USER_NOTIFICATION userNotif;
  memset(&userNotif, 0, sizeof(CE_USER_NOTIFICATION));
	//userNotif.ActionFlags= PUN_LED | PUN_VIBRATE | PUN_SOUND;
 // userNotif.pwszSound = _T("\\Windows\\Alarm2.wav");
  userNotif.ActionFlags =  PUN_LED | PUN_VIBRATE | PUN_DIALOG;
  userNotif.pwszDialogTitle = L"Salat Alarm";
  userNotif.pwszDialogText = msg;

//	if (hNotify)	CeClearUserNotification(hNotify);		// Clear before set
	ClearRunApp( LSS);
	hNotify = CeSetUserNotificationEx(0, &notifTrigger, &userNotif);
  // NULL because we do not care the action
  if (!hNotify) {
   hr = E_FAIL;
  } else {
   // close the handle as we do not need to use it further
  // CloseHandle(hNotify);
  }  
  return hr;
}
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
//// debug
//	TCHAR OutSSName[100];
//	pTownData pTown;
HKEY	hkey;
DWORD	size, type;
  switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:            
        // The DLL is being loaded for the first time by a given process.
        // Perform per-process initialization here.  If the initialization is successful, return TRUE; if unsuccessful, return FALSE.
				NTowns=0;
				if (ReadConfigFile( hModule) !=0)		return false; 	// lit mon fichier data.cfg si erreur alors sort
				Verbose=false;															// on ne veut rien afficher comme msg d'alerte
				DeuxLignes=true;
			  Refresh = true;
				SalatBlink[idFajr]=false;
				SalatBlink[idChourouk]=false;
				SalatBlink[idZuhr]=false;
				SalatBlink[idAsr]=false;
				SalatBlink[idMaghrib]=false;
				SalatBlink[idIsha]=false;
				Blinking=false;
				BlinkState=0;
				SeqAthan=0;
				date.a=0; date.m=0; date.j=0; date.h=0.0; // jour/mois/anne/heure.xxx
				CurrentMinute=-1;
				//UpdatePrincipaleSS();	// se fera ds le Paint calcule les horaires du jour
				// lecture de la registry
				if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, RegKey, 0, 0, &hkey) == ERROR_SUCCESS)
						{
						size = sizeof (bool);
						RegQueryValueEx (hkey, TEXT ("AlarmFajr"), 0, &type, (unsigned char *)&SalatAlarm.Fajr, &size);
						RegQueryValueEx (hkey, TEXT ("AlarmZuhr"), 0, &type, (unsigned char *)&SalatAlarm.Zuhr, &size);
						RegQueryValueEx (hkey, TEXT ("AlarmAsr"), 0, &type, (unsigned char *)&SalatAlarm.Asr, &size);
						RegQueryValueEx (hkey, TEXT ("AlarmMaghrib"), 0, &type, (unsigned char *)&SalatAlarm.Maghrib, &size);
						RegQueryValueEx (hkey, TEXT ("AlarmIsha"), 0, &type, (unsigned char *)&SalatAlarm.Isha, &size);
						RegCloseKey (hkey);
						}
// debug
//GetLocalTime(&tmhereDebug);
				g_hInst = (HINSTANCE)hModule;
				if (DRA::GetScreenCaps(LOGPIXELSY) == 192)	VGA = true;
													else											VGA = false;
        //load the icon
				if (VGA)	g_hIcon = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_ICONSalat));
						else	g_hIcon =(HICON)LoadImage(g_hInst, MAKEINTRESOURCE(IDI_ICONSalat), IMAGE_ICON, DRA::SCALEX(16), DRA::SCALEY(16) ,LR_DEFAULTCOLOR);

// debug enlever le hwind=0 ?
//				g_hWnd = 0;
        break;

    case DLL_PROCESS_DETACH:
        // The DLL is being unloaded by a given process.  Do any per-process clean up here, such as undoing what was done in
        // DLL_PROCESS_ATTACH.    The return value is ignored.
        DestroyIcon(g_hIcon);
        UnregisterClass( g_szPluginClass, g_hInst);
        g_hInst = NULL;
        break;           
    }
  return TRUE;
}
//-------------------------------------------------------------------------
// verifie si l'heure de priere est entre  la minute
bool VerifSalatProche(double salattime, Heure heure)
{
int msalattime, mheure;
double m, s;
int hi, mi;
// refaire l'arrondi comme pour l'affichage
	hi=salattime;
	m=(salattime-hi)*60;
	mi=(salattime-hi)*60;
	s=(m-mi)*60;
	if (s>=30)	{
							mi++;
							if (mi==60)	{
													mi=0; hi++;
													if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
//																			sprintf(SS, "erreur : arrondi au jour suivant");
						                          }	
													}
							}


	msalattime = hi*60+mi;
	mheure=heure.h*60+heure.m;
	if (mheure==msalattime)	return true;
				else							return false;
}
//-------------------------------------------------------------------------
void UpdatePrincipaleSS()
{
//	TCHAR SSF[25], SSZ[25], SSA[25], SSM[25], SSI[25];
TCHAR SS[25];
TCHAR LOutSS[100];
TCHAR LOutSSDate[SSlenght];
bool DSTApplies;
	//	ResetDate();		// added pour DLL Today
	//	ResetHeure();		// added pour DLL Today
	GetDate( Newdate);
	if (Newdate.a==date.a && Newdate.m==date.m && Newdate.j==date.j)	return;	// inutile de rafraichir car le meme jour
	date.a=Newdate.a;
	date.m=Newdate.m;
	date.j=Newdate.j;
	Verbose=false;
	ComputeSalatTime(); 
	DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	// Notify !
	// enregistrer les venements via CeSetUserNotificationEx
	wsprintf(LOutSSDate, L"    %s  %d  %s  %d\n\n",
					Days[CalculeJour(T+(TimeZone+12)/24.0/36525.0)], date.j, Mounths[date.m-1], date.a);
	wsprintf( LOutSS, L"Fajr %-6.5s  %s", Lh2hmiarrondie(SalatTimeC.Fajr, SS), LOutSSDate);
	if (SalatAlarm.Fajr)	SetUserNotif( SalatTimeC.Fajr, hNotifySalat.Fajr, L"Event Fajr", LOutSS);
	wsprintf( LOutSS, L"Zuhr %-6.5s  %s", Lh2hmiarrondie(SalatTimeC.Zuhr, SS), LOutSSDate);
	if (SalatAlarm.Zuhr)	SetUserNotif( SalatTimeC.Zuhr, hNotifySalat.Zuhr, L"Event Zuhr", LOutSS);
	wsprintf( LOutSS, L"Asr %-6.5s  %s", Lh2hmiarrondie(SalatTimeC.Asr, SS), LOutSSDate);
	if (SalatAlarm.Asr)	SetUserNotif( SalatTimeC.Asr, hNotifySalat.Asr, L"Event Asr", LOutSS);
	wsprintf( LOutSS, L"Maghrib %-6.5s  %s", Lh2hmiarrondie(SalatTimeC.Maghrib, SS), LOutSSDate);
	if (SalatAlarm.Maghrib)	SetUserNotif( SalatTimeC.Maghrib, hNotifySalat.Maghrib, L"Event Maghrib", LOutSS);
	wsprintf( LOutSS, L"Isha %-6.5s  %s", Lh2hmiarrondie(SalatTimeC.Isha, SS), LOutSSDate);
	if (SalatAlarm.Isha)	SetUserNotif( SalatTimeC.Isha, hNotifySalat.Isha, L"Event Isha", LOutSS);
}
//-------------------------------------------------------------------------
// verifie si l'heure de priere est entre depuis moins de mindelta
void CalculeTaillesAffichage(HWND hwnd)
{
RECT	rcWindBounds, rcMyBounds;
int rcLargeurCol, i;
	GetWindowRect( hwnd, &rcWindBounds); 
	// create a custom rectangle relative to the client area
	rcMyBounds.left		= DRA::SCALEX(1);
	rcMyBounds.right	= rcWindBounds.right - rcWindBounds.left;
	rcMyBounds.top		= DRA::SCALEY(2);
	// non valide	: rcMyBounds.bottom = rcWindBounds.bottom - rcWindBounds.top;   
	rcLargeurCol=(rcMyBounds.right-rcMyBounds.left - 10)/6;
	// ajuste 
	if (DeuxLignes)	{
									rcMyBounds.bottom=rcMyBounds.top + DRA::SCALEY(30);
									for (i=0; i<6; i++)
										{
										SalatRect[i][0].top=rcMyBounds.top;
										SalatRect[i][0].bottom=rcMyBounds.top + DRA::SCALEY(15);
										SalatRect[i][1].top=rcMyBounds.top + DRA::SCALEY(15);
										SalatRect[i][1].bottom=rcMyBounds.top + DRA::SCALEY(30);
										// largeur
										SalatRect[i][0].left=  rcMyBounds.left + i*rcLargeurCol;
										SalatRect[i][0].right= rcMyBounds.left + (i+1)*rcLargeurCol;
										SalatRect[i][1].left=  rcMyBounds.left + i*rcLargeurCol;
										SalatRect[i][1].right= rcMyBounds.left + (i+1)*rcLargeurCol;
										}
									}
		else					{
									rcMyBounds.bottom=rcMyBounds.top + DRA::SCALEY(15);
									for (i=0; i<6; i++)
										{
										SalatRect[i][1].top=rcMyBounds.top;
										SalatRect[i][1].bottom=rcMyBounds.bottom;
										// largeur
										SalatRect[i][1].left=	rcMyBounds.left + i*rcLargeurCol;
										SalatRect[i][1].right=rcMyBounds.left + (i+1)*rcLargeurCol;
										}
									}
		SalatRect[3][0].left	-=5;		// Magrib  dborde
		SalatRect[3][0].right	+=5;		// Magrib  dborde
		// Si nom long, la ville dborde
		SalatRect[5][1].right=rcMyBounds.right;
		// zone clickable
		rcGenerateArea.right=rcMyBounds.right;
		rcGenerateArea.left	=rcMyBounds.right-20;
		rcGenerateArea.top	=0;
		rcGenerateArea.bottom=rcMyBounds.bottom;
}
//-------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
PAINTSTRUCT ps;
RECT	rcWindBounds;
TCHAR SS[25];
HFONT            hFontOld;
//WCHAR            szTextBuffer[10];
COLORREF        crText;
  switch (msg)
		{
    case WM_CREATE:
			RefreshCalcRect=true;
			//InvalidateRect (hwnd, NULL, TRUE);
      break;

    case WM_TODAYCUSTOM_CLEARCACHE:		// sort des Options
			// debug [MARCHE PAS !], on devrait reforcer, le calcul et l'affichage
			if (ReadConfigFile( g_hInst) !=0)		return false; 	// lit mon fichier data.cfg si erreur alors sort
			Verbose=false;															// on ne veut rien afficher comme msg d'alerte
			Blinking=false;
			BlinkState=0;
			date.a=0; date.m=0; date.j=0; date.h=0.0; // jour/mois/anne/heure.xxxRefreshCalcRect=true;
      UpdatePrincipaleSS();	// Recalcule les horaires du jour car la ville a change
		  //Refresh = true;
			InvalidateRect (hwnd, NULL, TRUE);
			return 0;

		case WM_TODAYCUSTOM_QUERYREFRESHCACHE:		// Appel ttes les secondes environ
			// Check alarm
			SYSTEMTIME tmhere;
			GetLocalTime(&tmhere);
		  if (tmhere.wMinute != CurrentMinute)
          {
					if (SeqAthan==0)
						{
						CurrentMinute = tmhere.wMinute;
						Heure hhere;
						hhere.s=tmhere.wSecond;
						hhere.m=tmhere.wMinute;
						hhere.h=tmhere.wHour;
						if (VerifSalatProche(SalatTimeC.Fajr, hhere))		{
																														// Sonne 1 fois
																														SeqAthan=SeqAthanMax;
																														if (SalatAlarm.Fajr)
																																{
																																PlaySound (TEXT("SystemStart"), NULL, SND_SYNC);
																																PlaySound (TEXT("Notify"), NULL, SND_SYNC);
																																}
																														SalatBlink[idFajr]=true;
																														Blinking=true;
																														BlinkState=0;
																														}
						if (VerifSalatProche(SalatTimeC.Zuhr, hhere))		{
																														// Sonne 1 fois
																														SeqAthan=SeqAthanMax;
																														if (SalatAlarm.Zuhr)
																																{
																																PlaySound (TEXT("SystemStart"), NULL, SND_SYNC);
																																PlaySound (TEXT("Notify"), NULL, SND_SYNC);
																																}
																														SalatBlink[idZuhr]=true;
																														Blinking=true;
																														BlinkState=0;
																														}
						if (VerifSalatProche(SalatTimeC.Asr, hhere))		{
																														// Sonne 1 fois
																														SeqAthan=SeqAthanMax;
																														if (SalatAlarm.Asr)
																																{
																																PlaySound (TEXT("SystemStart"), NULL, SND_SYNC);
																																PlaySound (TEXT("Notify"), NULL, SND_SYNC);
																																}
																														SalatBlink[idAsr]=true;
																														Blinking=true;
																														BlinkState=0;
																														}
						if (VerifSalatProche(SalatTimeC.Maghrib, hhere))		{
																														// Sonne 1 fois
																														SeqAthan=SeqAthanMax;
																														if (SalatAlarm.Maghrib)
																																{
																																PlaySound (TEXT("SystemStart"), NULL, SND_SYNC);
																																PlaySound (TEXT("Notify"), NULL, SND_SYNC);
																																}
																														SalatBlink[idMaghrib]=true;
																														Blinking=true;
																														BlinkState=0;
																														}
						if (VerifSalatProche(SalatTimeC.Isha, hhere))		{
																														// Sonne 1 fois
																														SeqAthan=SeqAthanMax;
																														if (SalatAlarm.Isha)
																																{
																																PlaySound (TEXT("SystemStart"), NULL, SND_SYNC);
																																PlaySound (TEXT("Notify"), NULL, SND_SYNC);
																																}
																														SalatBlink[idIsha]=true;
																														Blinking=true;
																														BlinkState=0;
																														}
						}
					else	{
								if (--SeqAthan<=0)	{
																		SalatBlink[idFajr]=false;
																		SalatBlink[idChourouk]=false;
																		SalatBlink[idZuhr]=false;
																		SalatBlink[idAsr]=false;
																		SalatBlink[idMaghrib]=false;
																		SalatBlink[idIsha]=false;
																		Blinking=false;
																		InvalidateRect (hwnd, NULL, true);	// redessine sans cligontement
																		}
								}
					}	// de CurrentMinute
			// toggles blinking and Invalidate local area
			if (Blinking)	{
										if (++BlinkState>3)	BlinkState=0;
										if (SalatBlink[0])	{	// Fajr
																				if (DeuxLignes)	InvalidateRect (hwnd, & SalatRect[0][0], true);
																				InvalidateRect (hwnd, & SalatRect[0][1], true);
																				}
										for (int i=2; i<6; i++)
											if (SalatBlink[i])	{	// Zhur, Asr, Maghrib, Isha
																					if (DeuxLignes)	InvalidateRect (hwnd, & SalatRect[i-1][0], true);
																					InvalidateRect (hwnd, & SalatRect[i-1][1], true);
																					}
										}
			// Qd on revient des Options, il remet cyp  0 (hauteur du TodayPlugin), alors on Refresh
			if ( ((TODAYLISTITEM *)(wparam))->cyp==0)		Refresh=true;
			// check Refresh affichage 1 ou 2 lignes
			if (Refresh)	{
										Refresh = false;
								//PlaySound (TEXT("SystemStart"), NULL, SND_SYNC);
								//PlaySound (TEXT("Notify"), NULL, SND_SYNC);
//								PlaySound (TEXT("HKCU\\ControlPanel\\Sounds\\Clock"), NULL, SND_ASYNC);
									int ScreenHeight=DRA::GetScreenCaps(LOGPIXELSY);
										//if (DeuxLignes)	((TODAYLISTITEM *)(wparam))->cyp = ScreenHeight/3;	//32; en fonction du VGA
										//			else			((TODAYLISTITEM *)(wparam))->cyp = ScreenHeight/6;	//16;
										if (DeuxLignes)	((TODAYLISTITEM *)(wparam))->cyp = DRA::SCALEY(32); //en fonction du VGA
													else			((TODAYLISTITEM *)(wparam))->cyp = DRA::SCALEY(16);
										// recalcule les rectangle d'affichage des heures/noms des prieres
										CalculeTaillesAffichage( hwnd);
										return true;
										}
			else	return false;

		case WM_ERASEBKGND:
			TODAYDRAWWATERMARKINFO dwi;
			dwi.hdc=(HDC)wparam;
			GetClientRect(hwnd, &dwi.rc);
			dwi.hwnd = hwnd;
			SendMessage(GetParent(hwnd),TODAYM_DRAWWATERMARK,0,(LPARAM)&dwi);
			return true;

		case WM_PAINT:
      BeginPaint(hwnd, &ps);
			UpdatePrincipaleSS();
// debug
// force fajr  min+1
//-------------------------------------
//			SalatTimeC.Fajr=tmhereDebug.wHour+(tmhereDebug.wMinute+1)/60.0;
//-------------------------------------
			// draw the icon on the screen
      SetBkMode(ps.hdc, TRANSPARENT);
      GetWindowRect( hwnd, &rcWindBounds); 
			if (RefreshCalcRect)	{
														RefreshCalcRect=false;	// juste la 1ere fois
														CalculeTaillesAffichage( hwnd);
														}
			DrawIcon(ps.hdc, rcWindBounds.right-20, 0, g_hIcon);

			LOGFONT lf;
			HFONT hSysFont;
			HFONT hFont;
			hSysFont = (HFONT) GetStockObject(SYSTEM_FONT);
			GetObject(hSysFont, sizeof(LOGFONT), &lf);
			// use a bold font as 8 points
			lf.lfWeight = FW_BOLD;
			// Calculate the font size, making sure to round the result to the nearest integer
			lf.lfHeight = (long) -((8.0 * (double)GetDeviceCaps(ps.hdc, LOGPIXELSY) / 72.0)+.5);
			// create the font
			hFont = CreateFontIndirect(&lf);
			// Select the system font into the device context
			hFontOld = (HFONT) SelectObject(ps.hdc, hFont);
			// determine the theme's current text color
			//  this color will change when the user picks a new theme, so get it each time the display needs to be painted
			crText = SendMessage(GetParent(hwnd), TODAYM_GETCOLOR, (WPARAM) TODAYCOLOR_TEXT, NULL);
			// set that color
			SetTextColor(ps.hdc, crText);
			// draw the text juste  ct du bord
			COLORREF crBlinkColor;
			switch (BlinkState)
				{
				case 0 :	crBlinkColor=RGB(255,255,0); break;
				case 1 :	crBlinkColor=RGB(255 ,0, 0); break;
				case 2 :	crBlinkColor=RGB(0, 255, 0); break;
				case 3 :	crBlinkColor=RGB(0, 0, 255); break;
				}

			if (SalatBlink[idFajr])			SetTextColor(ps.hdc, crBlinkColor);
					else										SetTextColor(ps.hdc, crText);
					if (DeuxLignes)	DrawText(ps.hdc, TEXT("Fajr"), -1, &SalatRect[0][0], DT_CENTER);
			DrawText(ps.hdc, Lh2hmiarrondie(SalatTimeC.Fajr, SS), -1, &SalatRect[0][1], DT_CENTER);

			if (SalatBlink[idZuhr])			SetTextColor(ps.hdc, crBlinkColor);
					else										SetTextColor(ps.hdc, crText);
			if (DeuxLignes)	DrawText(ps.hdc, TEXT("Zuhr"), -1, &SalatRect[1][0], DT_CENTER);
			DrawText(ps.hdc, Lh2hmiarrondie(SalatTimeC.Zuhr, SS), -1, &SalatRect[1][1], DT_CENTER);

			if (SalatBlink[idAsr])			SetTextColor(ps.hdc, crBlinkColor);
					else										SetTextColor(ps.hdc, crText);
			if (DeuxLignes)	DrawText(ps.hdc, TEXT("Asr"), -1, &SalatRect[2][0], DT_CENTER);
			DrawText(ps.hdc, Lh2hmiarrondie(SalatTimeC.Asr, SS), -1, &SalatRect[2][1], DT_CENTER);

			if (SalatBlink[idMaghrib])	SetTextColor(ps.hdc, crBlinkColor);
					else										SetTextColor(ps.hdc, crText);
			if (DeuxLignes)	DrawText(ps.hdc, TEXT("Maghrib"), -1, &SalatRect[3][0], DT_CENTER);
			DrawText(ps.hdc, Lh2hmiarrondie(SalatTimeC.Maghrib, SS), -1, &SalatRect[3][1], DT_CENTER);

			if (SalatBlink[idIsha])			SetTextColor(ps.hdc, crBlinkColor);
					else										SetTextColor(ps.hdc, crText);
			if (DeuxLignes)	DrawText(ps.hdc, TEXT("Isha"), -1, &SalatRect[4][0], DT_CENTER);
			DrawText(ps.hdc, Lh2hmiarrondie(SalatTimeC.Isha, SS), -1, &SalatRect[4][1], DT_CENTER);

			SetTextColor(ps.hdc, crText);
			if (DeuxLignes)	DrawText(ps.hdc, TEXT("Ville"), -1, &SalatRect[5][0], DT_LEFT);
			DrawText(ps.hdc, TownName, -1, &SalatRect[5][1], DT_LEFT);
			// Select the previous font back into the device context
			SelectObject(ps.hdc, hFontOld);
			DeleteObject(hFont);

      EndPaint(hwnd, &ps);
      break;

    case WM_LBUTTONUP: 
				POINT pt;
				pt.x = GET_X_LPARAM(lparam); 
				pt.y = GET_Y_LPARAM(lparam); 
				if (PtInRect( &rcGenerateArea, pt))		MessageBox(NULL, TEXT("Press on the Left"), TEXT("Salat Time"), MB_OK);
				else	{
							DeuxLignes=!DeuxLignes;		// toggles 1 / 2 lignes d'affichage
							Refresh = true;
// debug inutile de recalculer les horaires /				date.a=0;
							}
        break;          

		default:
      return DefWindowProc(hwnd, msg, wparam, lparam);
  }

  return 0;
}
//-------------------------------------------------------------------------
HWND APIENTRY InitializeCustomItem(TODAYLISTITEM *tli, HWND parent)
{
WNDCLASS	wc; 
// if (!tli->fEnabled)    return NULL;
//	g_hInst = tli->hinstDLL; 

	//initilize the application class, and set the global window handle
	if (!GetClassInfo(g_hInst, g_szPluginClass, &wc))
    {
		// Create and register our window class for the today item
		memset(&wc, 0, sizeof(wc));
		wc.style         = 0;                   
		//  wc.style = CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc     = (WNDPROC) WindowProc;
		//  wc.cbClsExtra = 0;
		//  wc.cbWndExtra = 0;
		wc.hInstance     = g_hInst;
		wc.hIcon         = 0;
		wc.hCursor         = 0;
		wc.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
		//  wc.lpszMenuName = NULL;
		wc.lpszClassName = g_szPluginClass;
		// register our window
		if(!RegisterClass(&wc))
			{ 
			return NULL;
			}
		}
//    //create a new window
//    g_hWnd = CreateWindow(appName,appName,WS_VISIBLE | WS_CHILD,
//        CW_USEDEFAULT,CW_USEDEFAULT,240,0,hwndParent, NULL, g_hInst, NULL) ;

  g_hWnd=CreateWindow(g_szPluginClass, TEXT("SalatTime"), WS_VISIBLE | WS_CHILD, CW_DEFAULT, CW_DEFAULT, 0, 0, parent, NULL, g_hInst, NULL);
	//display the window
	if( tli->fEnabled)
		{
		ShowWindow (g_hWnd, SW_SHOWNORMAL);
		}

  return g_hWnd;
}
//-------------------------------------------------------------------------
// Message Handler for the options dialog
LRESULT WINAPI CustomItemOptionsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
SHINITDLGINFO shidi;
TCHAR fullPathFileName[256], path[256];
PROCESS_INFORMATION pi;
HKEY	hkey;
DWORD	size;

  switch (message)
  {
  case WM_INITDIALOG:
      {
      // Create a Done button and size it.  
      shidi.dwMask = SHIDIM_FLAGS;
      shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIZEDLGFULLSCREEN;
      shidi.hDlg = hDlg;
      SHInitDialog(&shidi);
			SendDlgItemMessage(hDlg, IDC_AlarmFajr, BM_SETCHECK, (SalatAlarm.Fajr ? BST_CHECKED : BST_UNCHECKED),0);
			SendDlgItemMessage(hDlg, IDC_AlarmZuhr, BM_SETCHECK, (SalatAlarm.Zuhr ? BST_CHECKED : BST_UNCHECKED),0);
			SendDlgItemMessage(hDlg, IDC_AlarmAsr, BM_SETCHECK, (SalatAlarm.Asr ? BST_CHECKED : BST_UNCHECKED),0);
			SendDlgItemMessage(hDlg, IDC_AlarmMaghrib, BM_SETCHECK, (SalatAlarm.Maghrib ? BST_CHECKED : BST_UNCHECKED),0);
			SendDlgItemMessage(hDlg, IDC_AlarmIsha, BM_SETCHECK, (SalatAlarm.Isha ? BST_CHECKED : BST_UNCHECKED),0);
			return TRUE; 
      }
      
      
  case WM_COMMAND:
       switch (LOWORD (wParam))
				{
				case IDOK:
						SalatAlarm.Fajr = SendDlgItemMessage(hDlg, IDC_AlarmFajr, BM_GETCHECK,0,0);
						SalatAlarm.Zuhr = SendDlgItemMessage(hDlg, IDC_AlarmZuhr, BM_GETCHECK,0,0);
						SalatAlarm.Asr = SendDlgItemMessage(hDlg, IDC_AlarmAsr, BM_GETCHECK,0,0);
						SalatAlarm.Maghrib = SendDlgItemMessage(hDlg, IDC_AlarmMaghrib, BM_GETCHECK,0,0);
						SalatAlarm.Isha = SendDlgItemMessage(hDlg, IDC_AlarmIsha, BM_GETCHECK,0,0);
						if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, RegKey, 0, 0, &hkey) == ERROR_SUCCESS)
                {
                size = sizeof (bool);
                RegSetValueEx (hkey, TEXT ("AlarmFajr"), 0, REG_DWORD, (const unsigned char *)&SalatAlarm.Fajr, size);
                RegSetValueEx (hkey, TEXT ("AlarmZuhr"), 0, REG_DWORD, (const unsigned char *)&SalatAlarm.Zuhr, size);
                RegSetValueEx (hkey, TEXT ("AlarmAsr"), 0, REG_DWORD, (const unsigned char *)&SalatAlarm.Asr, size);
                RegSetValueEx (hkey, TEXT ("AlarmMaghrib"), 0, REG_DWORD, (const unsigned char *)&SalatAlarm.Maghrib, size);
                RegSetValueEx (hkey, TEXT ("AlarmIsha"), 0, REG_DWORD, (const unsigned char *)&SalatAlarm.Isha, size);
								RegCloseKey (hkey);
                }
            EndDialog (hDlg, LOWORD(wParam));
            return TRUE;

        case IDC_BTLanceSalatTime:
// debug test
//            MessageBox (hDlg, TEXT("Appelle SalatTime"), TEXT("Debug"), MB_OK);
						// recuperer la registry du directory d'install puis executer
						GetModuleFileName((HMODULE)g_hInst, path, 256);   //returns full path with .exe name 
						TCHAR *pos = wcsrchr(path, '\\');   //gets the last occurrance of '\' 
						*(pos + 1) = TEXT('\0'); 
						wcscpy(fullPathFileName, path); 
						wcscat(fullPathFileName, TEXT("SalatTime.exe")); 
						CreateProcess( fullPathFileName, NULL, NULL, NULL, FALSE, CREATE_NEW_CONSOLE,
														NULL, NULL, NULL, &pi);
						return TRUE;

      //  case IDC_ReloadConfig:
						//FreeMem();	// libere les villes
						//if (ReadConfigFile( (HMODULE)g_hInst) !=0)		return FALSE;
						//break;
				}	
			break;
  }
  return FALSE;
}
//-------------------------------------------------------------------------
