//---------------------------------------------------------------------------
/*
Compute sun position and Muslims Salat times for particular date
Copyright (C) 2007  Lotfi BAGHLI

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*********************************************************
*** IF YOU ARE MUSLIM, PLEASE PRAY FOR MY FORGIVENESS ***
*********************************************************

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
//---------------------------------------------------------------------------
#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "maincmddll.h"
#pragma warning( disable :  4244)
//---------------------------------------------------------------------------

const double M_PI=3.1415926535897932384626433832795;
const double deg2rd = M_PI/180.0;
const double rd2deg = 180.0/M_PI;
const double SolarSiderealCorrection = 1.002738;
		Astre Soleil;
		SalatTimeStruct SalatTime, SalatTimeC;
		double JD, T,  // Jour Julien, Julien Century : T,
					theta0, theta,  // theta0 : temps sideral  Greenwich
					longitude, latitude;
		DateUT date; // date en jours
		Heure heure; // date en heure
		int TimeZone, TimeZoneTown, NTowns, TownSelected, Verbose, Convention;
		int DST;
		SalatTimeConfigStruct SalatTimeConfig[NConvention];
		LPTSTR Mounths[]={TEXT("Janvier"), TEXT("Fvrier"), TEXT("Mars"), TEXT("Avril"),
									TEXT("Mai"), TEXT("Juin"), TEXT("Juillet"), TEXT("Aot"),
									TEXT("Septembre"), TEXT("Octobre"), TEXT("Novembre"), TEXT("Dcembre")};
		LPTSTR Days[]={TEXT("Lundi"), TEXT("Mardi"), TEXT("Mercredi"), TEXT("Jeudi"), TEXT("Vendredi"), TEXT("Samedi"), TEXT("Dimanche")};
		TCHAR	CountryName[Namelenght], TownName[Namelenght];

//---------------------------------------------------------------------------
// Algorithms from 	http://www.jgiesen.de/SME/details/basics/meeus.htm#solar
//								 	http://www.jgiesen.de/SME/details/basics/index.htm
//  								http://stjarnhimlen.se/comp/riset.html#3
//									http://www.ummah.net/astronomy/saltime/
// modified by Lotfi BAGHLI on 15/01/2006 et 10/06/2006
//---------------------------------------------------------------------------

// Julian day: 86400 s, Julian year: 365.25 d, Julian Century: 36525 d
// Julian Day (valid from 1900/3/1 to 2100/2/28)
double JulianDay (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
	return (int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0;
}
//---------------------------------------------------------------------------
// rang du jour
/*
double rang_du_jour (int date, int month, int year)
{                                                                                         
int N1, N2, K, N;
	N1=(month*275)/9;
	N2=(month+9)/12;
	K=1+ (year-4*(int)(year/4)+2)/3;
	(K=2 pour une anne commune et K=1 pour une bissextile)
	Le rang du jour est donn par :
	N=N1-N2*K+date-30;
	return N;
} pas ncessaire */
//---------------------------------------------------------------------------
// Julian century depuis 01/01/2000  12h UT
double JulianCentury (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
  return ((int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0 - 2451545.0)/36525;
} 
//---------------------------------------------------------------------------
//Solar Coordinates (according to: Jean Meeus: Astronomical Algorithms), accuracy of 0.01 degree 
double SoleilLongitude( double T)   // L
{
double M, L0, DL, L, Lm;
	M = 357.52910 + 35999.05030*T - 0.0001559*T*T - 0.00000048*T*T*T; // mean anomaly, degree
	L0 = 280.46645 + 36000.76983*T + 0.0003032*T*T; // mean longitude, degree 
	DL = (1.914600 - 0.004817*T - 0.000014*T*T)*sin(deg2rd*M)
				+ (0.019993 - 0.000101*T)*sin(deg2rd*2*M) + 0.000290*sin(deg2rd*3*M); 
	L=L0 + DL; // true longitude, deg sans modulo
	Lm=L-360*(int)(L/360);
	if (Lm<0)	Lm+=360;
	return Lm*deg2rd; // true longitude, rd 
}
//---------------------------------------------------------------------------
// convert ecliptic longitude L (rd) to right ascension RA and declination delta
void eclipticL2RA_delta( double L, double & RA, double & delta)
{
double eps, X, Y, Z, R;
  eps = deg2rd*23.43999; // obliquity of ecliptic
	X = cos(L); Y = cos(eps)*sin(L); Z = sin(eps)*sin(L); R = sqrt(1.0-Z*Z); 
	delta = atan2(Z, R); // in rd 
	RA = 2*atan2(Y, X+R); //  in rd 
}
//---------------------------------------------------------------------------
//compute sidereal time at Greenwich (according to: Jean Meeus: Astronomical Algorithms ) 
double TempsSideral( double T)   // theta0
{
	double theta0, theta0m;
//	T siecle julien depuis 2000
	theta0=280.46061837 + 360.98564736629*T*36525 + 0.000387933*T*T - T*T*T/38710000.0;
	theta0m=theta0-360*(int)(theta0/360);
	if (theta0m<0)	theta0m+=360;
	return theta0m*deg2rd;    // TempsSideralen rd
}
//---------------------------------------------------------------------------
//convert tau, delta to horizon coordinates of the observer (altitude h, azimuth az) , needs latitude : beta
void equatorial2horizontal( double beta, double tau, double delta, double & h, double & az)
{
	h=asin( sin(beta)*sin(delta) + cos(beta)*cos(delta)*cos(tau));	// h en rd
	az =atan2( -sin(tau), cos(beta)*tan(delta) - sin(beta)*cos(tau))-M_PI;	// az en rd du SUD
	if (az<0)	az+=2*M_PI;
}
//---------------------------------------------------------------------------
//convert rad en heure
double rd2heure( double angle)
{
	return (angle*12.0/M_PI);
}
//---------------------------------------------------------------------------
// check DST applies ou non
bool CalcTimeZone( int a, int m, int j, int DST, int TimeZoneTown)
{      // ici on approxime TimeZoneTown avec TimeZone puisque a n'a pas d'importance
int jjdebut, jjfin, mmdebut, mmfin, ji, jour, JourToSwitch;
double T;
	if (DST==2) {JourToSwitch=4; mmdebut=4; mmfin=9;} // dernier vendredi d'avril / septembre
			else		{JourToSwitch=6; mmdebut=3; mmfin=10;}// dernier dimanche de mars / octobre
// recherchedernier dimanche de mars et dernier dimanche d'octobre
// DST applys 26-Mar, 02:00h    29-Oct, 03:00h   pour 2006
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmdebut, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjdebut=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmfin, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjfin=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	if (m>mmdebut && m<mmfin)	return true;
	if (m==mmdebut && j>=jjdebut)	return true;
	if (m==mmfin && j<jjfin)	return true;
	return false;
}
//---------------------------------------------------------------------------
//convert heure en rad
double heure2rd( double heure)
{
	return (heure*M_PI/12.0);
}
////---------------------------------------------------------------------------
////convert rad en deg min sec
//char * rd2degminsec( double angle, char * SS)
//{
//double h, m, s;
//int hi, mi;
//	h=angle*rd2deg;
//	hi=h;
//	m=(h-hi)*60;
//	mi=(h-hi)*60;
//	s=(m-mi)*60;
//	sprintf (SS,"%3d%02d'%02.0f\"", hi, mi,s);
//	return SS;
//}
////---------------------------------------------------------------------------
////convert rad en h min sec
//char * rd2hminsec( double angle, char * SS)
//{
//double h, m, s;
//int hi, mi;
//	h=rd2heure(angle);
//	hi=h;
//	m=(h-hi)*60;
//	mi=(h-hi)*60;
//	s=(m-mi)*60;
//	sprintf (SS,"%02dh%02d'%02.0f\"", hi, mi,s);
//	return SS;
//}
////---------------------------------------------------------------------------
////convert h en h min sec
//char * h2hminsec( double h, char * SS)
//{
//double m, s;
//int hi, mi;
//	hi=h;
//	m=(h-hi)*60;
//	mi=(h-hi)*60;
//	s=(m-mi)*60;
//	sprintf (SS,"%02dh%02d'%02.0f\"", hi, mi,s);
//	return SS;
//}
////---------------------------------------------------------------------------
////convert h en h min arondie
//char * h2hmiarrondie( double h, char * SS)
//{
//double m, s;
//int hi, mi;
//	hi=h;
//	m=(h-hi)*60;
//	mi=(h-hi)*60;
//	s=(m-mi)*60;
//	if (s>=30)	{
//							mi++;
//							if (mi==60)	{
//													mi=0; hi++;
//													if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
//																			sprintf(SS, "erreur : arrondi au jour suivant");
//																			return SS;
//						                          }	
//													}
//							}
//	sprintf(SS, "%02d:%02d",hi,mi);
//	return SS;
//}
//---------------------------------------------------------------------------
//convert h en h min arondie		Long
LPTSTR Lh2hmiarrondie( double h, LPTSTR SS)
{
double m, s;
int hi, mi;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	if (s>=30)	{
							mi++;
							if (mi==60)	{
													mi=0; hi++;
													if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
																			wsprintf(SS, TEXT("erreur : arrondi au jour suivant"));
																			return SS;
						                          }	
													}
							}
	wsprintf(SS, TEXT("%02d:%02d"),hi,mi);
	return SS;
}
//---------------------------------------------------------------------------
//recupere la date actuelle
void GetDate( DateUT & dateh)
{
	SYSTEMTIME tmhere;
	GetLocalTime(&tmhere);
	dateh.j=tmhere.wDay;
	dateh.m=tmhere.wMonth;
	dateh.a=tmhere.wYear;
	dateh.h=0.0;
	//printf("Date saisie : %d/%d/%d)\n", date.j, date.m, date.a);
}
//---------------------------------------------------------------------------
//saisi la date
void ResetDate()
{
	//printf("Entrez la date d'observation (d/m/a)\n");
//	scanf("%d/%d/%d", & date.j, & date.m, & date.a);
// debug
	SYSTEMTIME tmhere;
	GetLocalTime(&tmhere);
	date.j=tmhere.wDay;
	date.m=tmhere.wMonth;
	date.a=tmhere.wYear;
	//printf("Date saisie : %d/%d/%d)\n", date.j, date.m, date.a);
}
//---------------------------------------------------------------------------
//saisi l'heure
void ResetHeure()
{
	//printf("Entrez l'heure d'observation (h/m/s)\n");
//	scanf("%d/%d/%d", & heure.h, & heure.m, & heure.s);
// debug
	SYSTEMTIME tmhere;
	GetLocalTime(&tmhere);
	heure.s=tmhere.wSecond;
	heure.m=tmhere.wMinute;
	heure.h=tmhere.wHour;
	//printf("Date saisie : %d/%d/%d\n", heure.h, heure.m, heure.s);
	heure.ms=0;
}
//---------------------------------------------------------------------------
// les fonctions principales
//---------------------------------------------------------------------------
void ComputeZuhrHour()
{
double Z_GMT, GMST0;
//TCHAR SS[SSlenght];
	T=JulianCentury (date.j, date.m, date.a, 12);    // pour 12h
	//if (Verbose)	printf("T=%g  JC  12h GMT\n",T);
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	theta0=TempsSideral( T);
	GMST0=theta0-heure2rd(12);
	Z_GMT=rd2heure(Soleil.RA-GMST0-longitude);
// iteration bis
	if (Z_GMT<0) 	{// si ngatif, on se place  j-1
								Z_GMT+=24;
								T=JulianCentury (date.j-1, date.m, date.a, Z_GMT+24);    // pour LA vraie heure  GWT
								}
		else				T=JulianCentury (date.j, date.m, date.a, Z_GMT);    // pour LA vraie heure  GWT
	//if (Verbose)	printf("T=%g JC  %s\n",T, h2hminsec(Z_GMT, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	theta0=TempsSideral( T);
	GMST0=theta0-heure2rd(Z_GMT);
	SalatTime.Zuhr=TimeZone+rd2heure(Soleil.RA-GMST0-longitude);    // on le prend avec TimeZone
	if (SalatTime.Zuhr<0) SalatTime.Zuhr+=24;
}
//---------------------------------------------------------------------------
//compute pour une des 5 prieres
int ComputeTwilightHour(int TypeSalat, double & SalatHour)
{
double costau;
int Offset;
//TCHAR SS[SSlenght];
	SalatHour=0;
	switch (TypeSalat)
		{
		case idFajr : Soleil.h=-SalatTimeConfig[Convention].FajrTwilightAngle*deg2rd;
									Offset=-1;
									break;
		case idIsha : Soleil.h=-SalatTimeConfig[Convention].IshaTwilightAngle*deg2rd;
									Offset=+1;
									break;
		case idChourouk : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=-1;
									break;
		case idMaghrib : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=+1;
									break;
		}
	// commence par calculer au milieur de la journe le T et declinaison du soleil
	// iteration 1
	//if (Verbose)	printf(" 1st iter %s\n", h2hminsec(SalatTime.Zuhr-TimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatTime.Zuhr-TimeZone);    // pour LA vraie heure  GWT
	//if (Verbose)		printf("T=%g JC  %s\n", T, h2hminsec(SalatTime.Zuhr-TimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													Offset=+1;
													}
	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	//if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{//if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{//if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau)/SolarSiderealCorrection;
			SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			//if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, h2hminsec(SalatHour, SS));
			}
// corrected values, avec iterations
	//if (Verbose)	printf("** corrected values ** :\n");
	// iteration 2
	//if (Verbose)	printf(" 2nd iter  %s\n", h2hminsec(SalatHour-TimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatHour-TimeZone);    // pour LA vraie heure  GWT
	//if (Verbose)	printf("T=%g JC  %s\n", T, h2hminsec(SalatHour-TimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd(SalatHour-TimeZone);
 	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	//if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{//if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{//if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			//if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, h2hminsec(SalatHour, SS));
			}
	// iteration 3
	//if (Verbose)	printf(" 3rd iter  %s\n", h2hminsec(SalatHour-TimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatHour-TimeZone);    // pour LA vraie heure  GWT
	//if (Verbose)	printf("T=%g JC  %s\n", T, h2hminsec(SalatHour-TimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( Soleil.L, Soleil.RA, Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													//if (Verbose)	printf("h=%g  ie altitude %g\n", Soleil.h*rd2deg, rd2degminsec(Soleil.h, SS));
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd(SalatHour-TimeZone);
	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	//if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{//if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{//if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			//if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, h2hminsec(SalatHour, SS));
			}
	return 0;
}
//---------------------------------------------------------------------------
//Appelle les 2 methodes prcdentes pour calculer ttes les prieres
void ComputeSalatTime()
{
int erreur;
//TCHAR SS[SSlenght], SS2[SSlenght];
	// deja entre date=GetDate();
bool DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) TimeZone=1+TimeZoneTown;
						else  TimeZone=TimeZoneTown;
	// Calcul Zuhr
	ComputeZuhrHour();
	// Calcul Chourouk (lever)
	erreur=ComputeTwilightHour( idChourouk, SalatTime.Chourouk);
	// Calcul Maghrib (coucher)
	erreur=ComputeTwilightHour( idMaghrib, SalatTime.Maghrib);
	// Calcul Fajr (Twilight)
	erreur=ComputeTwilightHour( idFajr, SalatTime.Fajr);
	// Calcul Isha (Twilight) or Maghrib+
	if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus)
						SalatTime.Isha=SalatTime.Maghrib + SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min/60.0;
			else	erreur=ComputeTwilightHour( idIsha, SalatTime.Isha);
	// Calcul Asr (arccot(1+tan(B-D)))
	erreur=ComputeTwilightHour( idAsr, SalatTime.Asr);

	// calcule les vraies heures de prire
	SalatTimeC.Fajr=SalatTime.Fajr +SalatTimeConfig[Convention].SalatTimeAdjust.Fajr/60.0;
	SalatTimeC.Chourouk=SalatTime.Chourouk +SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk/60.0;
	if (SalatTimeConfig[Convention].ZuhrFixe)	SalatTimeC.Zuhr=SalatTimeConfig[Convention].ZuhrFixeHour;
			else SalatTimeC.Zuhr=SalatTime.Zuhr +SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr/60.0;
	SalatTimeC.Asr=SalatTime.Asr +SalatTimeConfig[Convention].SalatTimeAdjust.Asr/60.0;
	SalatTimeC.Maghrib=SalatTime.Maghrib +SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib/60.0;
	SalatTimeC.Isha=SalatTime.Isha  +SalatTimeConfig[Convention].SalatTimeAdjust.Isha/60.0;
}
//---------------------------------------------------------------------------
int ReadConfigFile(HANDLE hModule)
{
TCHAR FileName[]=TEXT("data.cfg");
int iAsr, iIsha_is_Maghrib_plus, iZuhrFixe, TownsCount=0;
TCHAR * p;
TownData ATown;		// on ne lit qu'une ville  la fois dans la Today DLL (V1.6)
FILE * DataFile;	//, * EchoFile;
int Code;
TCHAR Comment[201];
	TCHAR path[256]; 
	TCHAR fullPathFileName[256];	//, fullPathReadEcho[256]; 
	GetModuleFileName((HMODULE)hModule, path, 256);   //returns full path with .exe name 
	TCHAR *pos = wcsrchr(path, '\\');   //gets the last occurrance of '\' 
	*(pos + 1) = TEXT('\0'); 
	wcscpy(fullPathFileName, path); 
	wcscat(fullPathFileName, FileName); 
	//wcscpy(fullPathReadEcho, path); 
	//wcscat(fullPathReadEcho, TEXT("read_echo.cfg")); 
//MessageBox(NULL, fullPathFileName, TEXT("File read"), MB_OK);
	if( (DataFile=_wfopen( fullPathFileName, TEXT("r"))) == NULL )
				{
				STLOG_WRITE("Cannot open data.cfg file");
				STLOG_LASTERROR;
				 MessageBox(NULL, fullPathFileName, TEXT("File open error"), MB_OK);
				 return 1;
				 }
	//if( (EchoFile=_wfopen( fullPathReadEcho, TEXT("w"))) == NULL )
	//			{
	//			MessageBox(NULL, fullPathReadEcho, TEXT("File open error"), MB_OK);
	//			return 2;
	//			}
	//fprintf(EchoFile,"%s\n", "8 -----------------  File reading transcription  ---------------");
	while ( fscanf(DataFile,"%d", & Code) !=EOF)
	{
	//fprintf(EchoFile, "%d ", Code);
	switch ( Code)
	 {
//8 - Conventions
//8 Convention Name
	case 5 :
		fwscanf( DataFile, TEXT("%d"), & Convention);
		fgetws( Comment, 200, DataFile);
		p=wcstok(Comment,TEXT("\""));
		p=wcstok(NULL,TEXT("\""));
		wcscpy( SalatTimeConfig[Convention].Name, wcstok(p,TEXT("\"")));
		//fwprintf(EchoFile, TEXT("%-9d \"%s\"\n"), Convention, SalatTimeConfig[Convention].Name);
		break;
//8 Convention AsrSahfi/Hanafi FajrTwilightAngle IshaTwilightAngle Sunrise/SetAngle Isha_is_Maghrib_plus xx mn ZuhrFixe ZuhrHour(h)
	case 3 :
		fwscanf( DataFile,TEXT("%d"), & Convention);
		fwscanf( DataFile,TEXT("%d %lf %lf %lf %d %d %d %lf\n"), & iAsr, & SalatTimeConfig[Convention].FajrTwilightAngle, & SalatTimeConfig[Convention].IshaTwilightAngle,
								& SalatTimeConfig[Convention].Sunrise_setAngle,
								& iIsha_is_Maghrib_plus, & SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min,
								& iZuhrFixe, & SalatTimeConfig[Convention].ZuhrFixeHour);
		//fwprintf(EchoFile, TEXT("%-9d  %-14d  %-16g  %-16g  %-15g  %-19d  %-4d  %-7d  %-15.7f\n"), Convention, iAsr,
		//				SalatTimeConfig[Convention].FajrTwilightAngle, SalatTimeConfig[Convention].IshaTwilightAngle,
		//				SalatTimeConfig[Convention].Sunrise_setAngle,
		//				iIsha_is_Maghrib_plus, SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min,
		//				iZuhrFixe, SalatTimeConfig[Convention].ZuhrFixeHour);
		SalatTimeConfig[Convention].AsrShafi=(iAsr==1);
		SalatTimeConfig[Convention].Isha_is_Maghrib_plus=(iIsha_is_Maghrib_plus==1);
		SalatTimeConfig[Convention].ZuhrFixe=(iZuhrFixe==1);
		break;
//- Time (mn) to add to get Salat
//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	case 4 :
		fwscanf( DataFile,TEXT("%d"), & Convention);
		fwscanf( DataFile,TEXT("%lf %lf %lf %lf %lf %lf\n"), & SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, & SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk,
						& SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, & SalatTimeConfig[Convention].SalatTimeAdjust.Asr,
						& SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, & SalatTimeConfig[Convention].SalatTimeAdjust.Isha);
		//fwprintf(EchoFile, TEXT("%-9d  %-7g  %-7g  %-7g  %-7g  %-7g  %-7g\n"), Convention, SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk,
		//				SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, SalatTimeConfig[Convention].SalatTimeAdjust.Asr,
		//				SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, SalatTimeConfig[Convention].SalatTimeAdjust.Isha);
		break;
//8 NumberOfTowns  TownSelected  Verbose
	case 1 :
		fwscanf( DataFile,TEXT("%d %d %d\n"), & NTowns, & TownSelected, & Verbose);
		//fwprintf(EchoFile, TEXT("%-13d  %-12d  %-7d\n"), NTowns, TownSelected, Verbose);
		if (NTowns<=0) {
					MessageBox(NULL, TEXT("Invalid number of towns in data.cfg"), TEXT("Read error"), MB_OK);
					return 6;
					}
		break;
//8 - Town location and TimeZone
//8 Country   Name            latitude   longitude TimeZone DST
	case 2 :
		fwscanf( DataFile,TEXT("%s %s %lf %lf %d %d %d\n"), & ATown.CountryName, & ATown.TownName,
						& ATown.latitude, & ATown.longitude,
						& ATown.TimeZoneTown, & ATown.DST, & ATown.Convention);
		//fwprintf(EchoFile, TEXT("%-15s  %-15s  %-10lf  %-10lf  %-7d  %-2d  %-2d\n"), ATown.CountryName, ATown.TownName,
		//				ATown.latitude, ATown.longitude,
		//				ATown.TimeZoneTown, ATown.DST, ATown.Convention);
		if (TownSelected==TownsCount)	{
					longitude=deg2rd*ATown.longitude;
					latitude=deg2rd*ATown.latitude;
					wcscpy( CountryName, ATown.CountryName);
					wcscpy( TownName, ATown.TownName);
					TimeZoneTown=ATown.TimeZoneTown;
					DST=ATown.DST;
					Convention=ATown.Convention;
					//MessageBox(NULL, TownName, TEXT("Found town"), MB_OK);
					}
		TownsCount++;
		break;
// Commentaire
	 case 8 :
		fgetws( Comment, 200, DataFile);
		////fseek( EchoFile, -1, SEEK_END);
	 //long curpos;
  // curpos = ftell(EchoFile);
	 //fseek(EchoFile, curpos-1, SEEK_SET);
		//fwprintf(EchoFile, TEXT("%s"), Comment);
		break;

		default :
		MessageBox(NULL, TEXT("bad format of data.cfg"), TEXT("Read error"), MB_OK);
		return 3;
		}   // switch

	}  // while
	fclose( DataFile);
	//// Ferme aussi le fichier de sortie rd_echo.dat
	//fclose( EchoFile);
	if (NTowns != TownsCount) {
				MessageBox(NULL, TEXT("Number of towns does not match NTowns"), TEXT("Read error"), MB_OK);
				return 4;
				}
	if (TownSelected<0 || TownSelected>=NTowns) 
									{
									MessageBox(NULL, TEXT("Selected town out of range"), TEXT("Read error"), MB_OK);
									return 5;
									}
	return 0;
}
//---------------------------------------------------------------------------
int CalculeNjdumois(int m, int annee)
{
int Nonbissextile=(annee-4*(int)(annee/4)+2)/3;  // 1 pour une anne commune et  0 pour une bissextile)
	if (m==1 || m==3 || m==5 || m==7
	 || m==8 || m==10 || m==12) 	return 31;
			else	{
						if (m==2) {if (Nonbissextile) return 28;
															else				return 29;
											}
								else  return 30;
				}
}
//---------------------------------------------------------------------------
int CalculeJour(double T) //  pertir du siecle Julien
{
double jour=T*36525+5;   
	return jour-7*(int)(jour/7);
}
//---------------------------------------------------------------------------
