//---------------------------------------------------------------------------

#ifndef maincmdH
#define maincmdH

extern const double M_PI;
extern const double deg2rd;
extern const double rd2deg;
extern const double SolarSiderealCorrection;

//---------------------------------------------------------------------------
struct Astre  { double az,  h,      // coord. horizontal
                delta,  tau, // coord equatorial
                RA,                // ascension droite
								L;                //longitude rele
							};
#define idFajr 0
#define idChourouk 1
#define idZuhr 2
#define idAsr 3
#define idMaghrib 4
#define idIsha 5

#define NConvention 9
#define Namelenght 80
#define SSlenght 160

struct SalatTimeStruct  { double Fajr, Chourouk, Zuhr, Asr, Maghrib, Isha;};
struct DateUT  { int j, m, a; double h; // jour/mois/anne/heure.xxx
							};
struct Heure  { int ms, s, m, h;  // milisec, secondes/, minutes, heures
							};
struct TownData { TCHAR CountryName[Namelenght], TownName[Namelenght];
									double longitude, latitude;
									int TimeZoneTown, Convention, DST;
							};
struct SalatTimeConfigStruct {
					SalatTimeStruct SalatTimeAdjust;
					bool AsrShafi, Isha_is_Maghrib_plus, ZuhrFixe;
					double FajrTwilightAngle, IshaTwilightAngle, Sunrise_setAngle;
					int Isha_is_Maghrib_plus_min;
					double ZuhrFixeHour;
					TCHAR Name[Namelenght];
					};
//---------------------------------------------------------------------------
	double JulianDay (int date, int month, int year, double UT);
	//double rang_du_jour (int date, int month, int year);
	double JulianCentury (int date, int month, int year, double UT);
	double SoleilLongitude( double T);
	void eclipticL2RA_delta( double L, double & RA, double & delta);
	double TempsSideral( double T);
	void equatorial2horizontal( double beta, double tau, double delta, double & h, double & az);
	double rd2heure( double angle);
	bool CalcTimeZone( int a, int m, int j, int DST, int TimeZoneTown);
	double heure2rd( double heure);
	//LPTSTR rd2degminsec( double angle, LPTSTR SS);
	//LPTSTR rd2hminsec( double angle, LPTSTR SS);
	//LPTSTR h2hminsec( double h, LPTSTR SS);
	//LPTSTR h2hmiarrondie( double h, LPTSTR SS);
	LPTSTR Lh2hmiarrondie( double h, LPTSTR SS);
	int CalculeNjdumois(int m, int annee);
	int CalculeJour(double T);
	void GetDate( DateUT & dateh);
	void ResetDate();
	void ResetHeure();
//---------------------------------------------------------------------------
	int ReadConfigFile(HANDLE hModule);
	//void WriteConfigFile();
	void ComputeSalatTime();
	void ComputeZuhrHour();
	int ComputeTwilightHour(int TypeSalat, double & SalatHour);
	extern Astre Soleil;
	extern SalatTimeStruct SalatTime, SalatTimeC;
	extern double JD, T,  // Jour Julien, Julien Century : T,
				theta0, theta,  // theta0 : temps sideral  Greenwich
				longitude, latitude;
	extern DateUT date; // date en jours
	extern Heure heure; // date en heure
	extern int TimeZone, TimeZoneTown, NTowns, TownSelected, Verbose, Convention;
	extern int DST;
	extern SalatTimeConfigStruct SalatTimeConfig[NConvention];
	extern LPTSTR Mounths[];
	extern LPTSTR Days[];
	extern TCHAR CountryName[Namelenght], TownName[Namelenght];

//---------------------------------------------------------------------------
#endif
